#define __FONT_CPP__
#include "CFont.h"

CFONT::CFONT(LPDIRECT3DDEVICE9 d,char *fontname,int w,int h):pFont(NULL),dxdiv(d){
	//dxdiv=d;//foCXRs[
	SetFont(fontname,w,h);//tHgɓ
}
//Rs[RXgN^
CFONT::CFONT(CFONT &src){
	if(pFont!=NULL) pFont->Release();
	dxdiv=src.dxdiv;//DXfoCX̃Rs[
	pDesc=src.pDesc;
	D3DXCreateFontIndirect(dxdiv,&pDesc,&pFont);
}
// Rs[ėp͖̂{͖
CFONT & CFONT::operator = ( const CFONT & src){
   	if(pFont!=NULL) pFont->Release();
	dxdiv=src.dxdiv;//DXfoCX̃Rs[
	pDesc=src.pDesc;
	D3DXCreateFontIndirect(dxdiv,&pDesc,&pFont);
	return *this;
}


void CFONT::SetFont(char *fontname,int w,int h){
	ReleaseFontObject();//Ⴄ

	pDesc.Weight =w ; pDesc.Height=h;
	strncpy_s(pDesc.FaceName,32,fontname,_TRUNCATE);			//tHg̖O
	
	pDesc.CharSet =SHIFTJIS_CHARSET;	//VtgWXg
	pDesc.Italic=FALSE;				//C^bNȂ
	pDesc.MipLevels=D3DX_DEFAULT;		//~bv}bv͏ݒɍ킹
	pDesc.OutputPrecision=OUT_DEFAULT_PRECIS;//o͐x̓fBtHg
	//sb`Ə
	//DEFAULT_PITCH, FIXED_PITCH, VARIABLE_PITCH
	//FF_DECORATIVE, FF_DONTCARE, FF_MODERN, FF_ROMAN, FF_SCRIPT, FF_SWISS
	//FF_ROMAN, FF_MODERN, FF_SCRIPT
	pDesc.PitchAndFamily = DEFAULT_PITCH | FF_SWISS;
	pDesc.Quality = DEFAULT_QUALITY;	//o͕i̓fBtHg 
	
	//tHg𐶐
	D3DXCreateFontIndirect(dxdiv,&pDesc,&pFont);
}

CFONT::~CFONT(){
	ReleaseFontObject();
}
void CFONT::ReleaseFontObject(void){
	if(pFont!=NULL) pFont->Release();
}


void CFONT::DrawString(int x,int y, char *str,D3DCOLOR color){
	//LostFont();
	//ResetFont();
	RECT rect;
	SetRect(&rect, x, y, CW_USEDEFAULT, CW_USEDEFAULT);
	// tHgo XvCgȂ@@O܂Ł@``@l߁@F
	pFont->DrawText(NULL , str ,-1, &rect, DT_LEFT | DT_NOCLIP, color);
}

void CFONT::LostFont(void){
	if(pFont!=NULL){ pFont->OnLostDevice();}
}
void CFONT::ResetFont(void){
	if(pFont!=NULL) pFont->OnResetDevice();
}