//-------------------------------------------------------------------------------------------------
// t@CFCTLVer.cpp
// Rg@FCTLVerNX̃o֐܂Ƃ߂CPPt@C
// Copyright FK.Ohishi@2009.11.12
//-------------------------------------------------------------------------------------------------
#include "CTLVer.h"

//-----------------------------------------------------------------------------------------------
// ֐FCTLVer::Init
// @eF2DIuWFNg̏
// @@@@SWƃTCYƐݒ肵AeV[Init֐ŌĂяo
//-----------------------------------------------------------------------------------------------
void CTLVer::Init()
{
	ZeroMemory( ver , sizeof(TLVERTEX)*4 );

	for(int i=0 ; i<4 ; i++){
		ver[i].rhw		= 1.0;
		ver[i].x		= center.x + ((i==1 || i==2) ? (size.x/2) : (size.x/-2)) ;
		ver[i].y		= center.y + ((i==2 || i==3) ? (size.y/2) : (size.y/-2)) ;
		ver[i].z		= 0.0f;
		ver[i].color	= D3DCOLOR_ARGB(0xff,0xff,0xff,0xff);
		ver[i].tu		= ((i==1 || i==2) ? 1.0f : 0.0f);
		ver[i].tv		= ((i==2 || i==3) ? 1.0f : 0.0f);
	}
	rad=0;
}


//-----------------------------------------------------------------------------------------------
// ֐FCTLVer::SetPos
// @eFSWƃTCYQc|ŜS_̒_WZbg
//-----------------------------------------------------------------------------------------------
void CTLVer::SetPos()
{
	float tx,ty;//vZp

	//float r = theta / 180.0f * PI ;

	for(int i=0;i<4;i++){
		//[JW
		tx = size.x * ( (i==0||i==3)? -0.5f :  0.5f) ;
		ty = size.y * ( (i==2||i==3)?  0.5f : -0.5f) ;
		//XVW@@ړ@{@]ij
		ver[i].x = center.x + tx * cos(rad) - ty * sin(rad);
		ver[i].y = center.y + tx * sin(rad) + ty * cos(rad);
	}
/*
	ver[0].x = center.x - (size.x/2);	ver[0].y = center.y - (size.y/2);
	ver[1].x = center.x + (size.x/2);	ver[1].y = center.y - (size.y/2);
	ver[2].x = center.x + (size.x/2);	ver[2].y = center.y + (size.y/2);	
	ver[3].x = center.x - (size.x/2);	ver[3].y = center.y + (size.y/2);		
*/
}

//-----------------------------------------------------------------------------------------------
// ֐FCTLVer::SetColor
// @eF_J[̃Zbg
// PFF
// QF_
//-----------------------------------------------------------------------------------------------
void CTLVer::SetColor(D3DCOLOR c, int point)
{
	for(int i=0 ; i<point ; i++){
		ver[i].color = c;
	}
}

//-----------------------------------------------------------------------------------------------
// ֐FCTLVer::SetUV
// @eF_̂tuWZbg
// PFw̕
// QFx̕
// RFw̃R}ʒu
// SFx̃R}ʒu
// TFE]tO
//-----------------------------------------------------------------------------------------------
void CTLVer::SetUV(int cx , int cy , int nx , int ny , bool turn)
{
	float w,h;

	// OZh~
	if(cx == 0 || cy == 0){
		MessageBox(NULL,"cx == 0 or cy == 0","SetTLVerUV",MB_OK);
		return;
	}
	w = 1.0f / cx;
	h = 1.0f / cy;

	ver[0].tu = w * nx;		ver[0].tv = h * ny;
	ver[1].tu = w * (nx+1);	ver[1].tv = h * ny;
	ver[2].tu = w * (nx+1);	ver[2].tv = h * (ny+1);
	ver[3].tu = w * nx;		ver[3].tv = h * (ny+1);

	if(turn)
	{
		float tu	= ver[0].tu;
		ver[0].tu	= ver[1].tu;
		ver[1].tu	= tu;
		tu			= ver[2].tu; 
		ver[2].tu	= ver[3].tu;
		ver[3].tu	= tu;
	}

}

//-----------------------------------------------------------------------------------------------
// ֐FCTLVer::Draw
// @eFQc|S̕`
// PFDirectX`foCX
// QFeNX`|C^
//-----------------------------------------------------------------------------------------------
void CTLVer::Draw(LPDIRECT3DDEVICE9 d , LPDIRECT3DTEXTURE9 tex)
{
	d->SetRenderState(D3DRS_LIGHTING , FALSE);
	d->SetFVF(FVF_TLVERTEX);
	d->SetTexture(0,tex);
	d->DrawPrimitiveUP(D3DPT_TRIANGLEFAN, 2, ver, sizeof(TLVERTEX));
}
