#include"PlayerStatus.h"
//̃NXgꍇ錾Oɉ̏Ă
//extern LPDIRECT3DDEVICE9	g_pd3ddev;		
LPDIRECT3DDEVICE9 Device::d = NULL;	//foCXNX̏iK{j(LN^NXƘA)
//tHg


PlayerStatus::PlayerStatus(){
	//|S
	Body.Init();
	RightArm.Init();
	LeftArm.Init();
	Dead.Init();

	Body.size = D3DXVECTOR2(128,128);
	RightArm.size = D3DXVECTOR2(128,128);
	LeftArm.size = D3DXVECTOR2(128,128);
	Dead.size = D3DXVECTOR2(128,128);

	size_y=128;

	Body.SetColor(D3DCOLOR_ARGB(255,255,255,255));
	RightArm.SetColor(D3DCOLOR_ARGB(255,255,255,255));
	LeftArm.SetColor(D3DCOLOR_ARGB(255,255,255,255));
	Dead.SetColor(D3DCOLOR_ARGB(0,255,0,0));

	Body.SetPos();
	RightArm.SetPos();
	LeftArm.SetPos();
	Dead.SetPos();

	WldPos=D3DXVECTOR2(0,0);

	//eNX`
	BodyTex.LoadTex("data\\tex\\player\\Player_Body_2.png",4608,512,NULL,d);
	LeftArmTex.LoadTex("data\\tex\\player\\Player_Left_Arm_HG_2.png",4608,512,NULL,d);
	RightArmTex.LoadTex("data\\tex\\player\\Player_Right_Arm_HG_2.png",4608,512,NULL,d);
	DeadTex.LoadTex("data\\tex\\player\\Player_Dead.png",1024,512,NULL,d);
	
	BodyAnim.x=0; BodyAnim.y=0;
	ArmAnim.x=0;  ArmAnim.y=0;

	Body.SetUV(9,1,0,0,false);
	LeftArm.SetUV(9,1,0,0,false);
	RightArm.SetUV(9,1,0,0,false);
	Dead.SetUV(2,1,0,0,true);
	
	AttackInit();
	BulletInit();

	MaxBullet=MAG_MAX*3;
	NowBullet=MAG_MAX;
	Life=100;
	HitSize=D3DXVECTOR2(128,128);
	DmgFlg=true;
	dmgcount=0;
	Hit=0;

	DamegeSE[0].LoadFile(L"data\\sound\\player\\himei1.wav");
	DamegeSE[1].LoadFile(L"data\\sound\\player\\himei2.wav");
	DamegeSE[2].LoadFile(L"data\\sound\\player\\himei3.wav");

	DeadSE.LoadFile(L"data\\sound\\player\\dead1.wav");

}

//vC[WZbg
void PlayerStatus::SetPos(){
	Body.center = ScrPos;
	LeftArm.center = ScrPos+D3DXVECTOR2(4,-21);
	RightArm.center = ScrPos+D3DXVECTOR2(4,-21);
		
	Dead.center=ScrPos;


	Body.SetUV(9,1,(int)BodyAnim.x,0,false);
	LeftArm.SetUV(9,1,(int)ArmAnim.x,0,false);
	RightArm.SetUV(9,1,(int)ArmAnim.x,0,false);
	
	Body.SetPos();
	LeftArm.SetPos();
	RightArm.SetPos();

	Dead.SetPos();

}
//WȊOŁi펞XV̂̏j
void PlayerStatus::Update(){
	//_[W̖GԂ̏
	dmgcount -= 0.005;
	if(!DmgFlg){
		Body.SetColor(D3DCOLOR_ARGB(128,255,255,255));
		RightArm.SetColor(D3DCOLOR_ARGB(128,255,255,255));
		LeftArm.SetColor(D3DCOLOR_ARGB(128,255,255,255));
	}else{
		Body.SetColor(D3DCOLOR_ARGB(255,255,255,255));
		RightArm.SetColor(D3DCOLOR_ARGB(255,255,255,255));
		LeftArm.SetColor(D3DCOLOR_ARGB(255,255,255,255));
	}

	if(dmgcount<0){
		//GԂ̓_ŏ
		dmgcount=0; 
		DmgFlg=true;
	}
}


//vC[OtBbN\
void PlayerStatus::Draw(){

		LeftArm.Draw(d,LeftArmTex.GetTex());
		Body.Draw(d,BodyTex.GetTex());
		RightArm.Draw(d,RightArmTex.GetTex());

		Dead.Draw(d,DeadTex.GetTex());

}



//U֘A
void PlayerStatus::AttackInit(){
	//Ƃ肠̎_Ō܂ĂvfĂ
	ZeroMemory( ver , sizeof(TLVERTEX)*10 );
	for(int i=0 ; i<10 ; i++){
		ver[i].rhw		= 1.0;
		ver[i].z		= 0.0f;
		ver[i].color	= D3DCOLOR_ARGB(64,255,255,0);
		ver[i].tu		= 0;
		ver[i].tv		= 0;

	}
}
//U֘AXV
void PlayerStatus::AttackUpdate(D3DXVECTOR2 mousePos,float HitPower){
	//ƂŊ֐ɈipxyV[^lzA˒jǉBƂ肠͌ŒlɂĂ
	float rad=DEG2RAD(11.0f-HitPower*10);		//Ɓipxj͌Œl(ƃWAɕϊĂ)

	D3DXVECTOR2 endpos=mousePos-(ScrPos+D3DXVECTOR2(4,-22));	//}EXWłA`iɐj	
	
	int i=1;					//forp̏ݒ莮
	float Rad=rad*(-1);			//for͕ʂ̌^̕ϐ𓯎ɏݒ莮ɒ`łȂdlȂ̂
	
	


	D3DXVECTOR2 B=D3DXVECTOR2(ScrPos.x+100,ScrPos.y);
	D3DXVECTOR2 AB=B-ScrPos;
	D3DXVECTOR2 AC=mousePos-ScrPos;
	
	
	//rp摜̉]px߂鏈
	ArmRad=acos(D3DXVec2Dot(&AB,&AC)/(sqrt(pow(AB.x,2)+pow(AB.y,2))*sqrt(pow(AC.x,2)+pow(AC.y,2))));

	//px
	//if(ArmRad > DEG2RAD(45))ArmRad=DEG2RAD(45);		//ɊpxĂ߂Ȃ΂ȂȂ
	if(D3DXVec2CCW(&AB,&AC)<0)ArmRad *= -1;			//߂


	RightArm.rad=ArmRad;
	LeftArm.rad=ArmRad;



	//ver[0].x=ScrPos.x;			//+60(e)
	//ver[0].y=ScrPos.y;			//-27(e)
	//(+4,-22)//r|S̒Sʒu
	ver[0].x=((ScrPos.x+60)-(ScrPos.x+4))*cos(ArmRad) - ((ScrPos.y-27)-(ScrPos.y-22))*sin(ArmRad) +(ScrPos.x+4);
	ver[0].y=((ScrPos.x+60)-(ScrPos.x+4))*sin(ArmRad) + ((ScrPos.y-27)-(ScrPos.y-22))*cos(ArmRad) +(ScrPos.y-22);


	for(;Rad<rad || i<10 ;Rad+=rad/AT_POLYGON_MAX*2,i++){	
		ver[i].x=endpos.x*cos(Rad)-endpos.y*sin(Rad) + ScrPos.x+4;
		ver[i].y=endpos.x*sin(Rad)+endpos.y*cos(Rad) + ScrPos.y-22;
	}



}
//U֘A`
void PlayerStatus::AttackDraw(){
	d->SetRenderState(D3DRS_LIGHTING , FALSE);
	d->SetFVF(FVF_TLVERTEX);
	d->SetTexture(0,NULL);
	d->DrawPrimitiveUP(D3DPT_TRIANGLEFAN, AT_POLYGON_MAX, ver, sizeof(TLVERTEX));

}




//eۃm
void PlayerStatus::BulletInit(){
	ZeroMemory( bulletver , sizeof(TLVERTEX)*48 );
	for(int i=0 ; i<48 ; i++){
		bulletver[i].rhw	= 1.0;
		bulletver[i].x		= 0.0f;
		bulletver[i].y		= 0.0f;
		bulletver[i].z		= 0.0f;
		bulletver[i].tu		= 0;
		bulletver[i].tv		= 0;
	}
	for(int i=0;i<12;i++){
		BulletLife[i]=true;
	}
}

//eۂ̍XV
void PlayerStatus::BulletUpdate(D3DXVECTOR2 mousePos){
	for(int i=0;i<12;i++){
		if(BulletLife[i]){
			BulletAlfa[i]=255;
			bulletver[i*4].color  = D3DCOLOR_ARGB(0,255,255,255);
			bulletver[i*4+1].color= D3DCOLOR_ARGB((int)(BulletAlfa[i]*0.3f),255,255,128);
			bulletver[i*4+2].color= D3DCOLOR_ARGB((int)(BulletAlfa[i]*0.5f),255,255,128);
			bulletver[i*4+3].color= D3DCOLOR_ARGB((int)(BulletAlfa[i]*1),255,255,0);

			bulletver[i*4].x= ((ScrPos.x+60)-(ScrPos.x+4))*cos(ArmRad) - ((ScrPos.y-27)-(ScrPos.y-22))*sin(ArmRad) +(ScrPos.x+4);
			bulletver[i*4].y= ((ScrPos.x+60)-(ScrPos.x+4))*sin(ArmRad) + ((ScrPos.y-27)-(ScrPos.y-22))*cos(ArmRad) +(ScrPos.y-22);

			bulletver[i*4+1].x=(bulletver[i*4].x+mousePos.x)/2;					//˒̒Ԓn_
			bulletver[i*4+1].y=(bulletver[i*4].y+mousePos.y)/2;					//S߂_̈ʒuẄύXɂȂĂiej
			bulletver[i*4+2].x=(bulletver[i*4].x+mousePos.x)/2;					//˒̒Ԓn_
			bulletver[i*4+2].y=(bulletver[i*4].y+mousePos.y)/2;
			


			bulletver[i*4+3].x=mousePos.x;						//˒En_iɐݒ肷B͉j
			bulletver[i*4+3].y=mousePos.y;
			BulletLife[i]=false;								//ẽtOgpɂ
			break;												//SeCɔ˂Ȃ悤ɂ
		}
	}

}
//eۂXɏ鏈
void PlayerStatus::BulletUpdate2(){
	for(int i=0;i<12;i++){
		if(!BulletLife[i]){
			BulletAlfa[i]-=5;
			bulletver[i*4].color  = D3DCOLOR_ARGB(0,255,255,255);
			bulletver[i*4+1].color= D3DCOLOR_ARGB((int)(BulletAlfa[i]*0.3f),255,255,128);
			bulletver[i*4+2].color= D3DCOLOR_ARGB((int)(BulletAlfa[i]*0.5f),255,255,128);
			bulletver[i*4+3].color= D3DCOLOR_ARGB((int)(BulletAlfa[i]*1),255,255,0);
			if(BulletAlfa[i]<=0)BulletLife[i]=true;
		}
	}
}
//eۂ̕`
void PlayerStatus::BulletDraw(){
	d->SetRenderState(D3DRS_LIGHTING , FALSE);
	d->SetFVF(FVF_TLVERTEX);
	d->SetTexture(0,NULL);
	d->DrawPrimitiveUP(D3DPT_LINELIST,24, bulletver, sizeof(TLVERTEX));
}


//UXV
void PlayerStatus::RelordUpdate(){
	ArmAnim.x += 0.3f;
	if(ArmAnim.x>8){
		if(NowBullet>0)MaxBullet+=NowBullet;	//eqɒe򂪗]Ă瑍e򐔂ɒǉiȂƃ[hɗ]ê͎Ăj
		if(MaxBullet > MAG_MAX){
			NowBullet =  MAG_MAX;
			MaxBullet -= MAG_MAX;
		}else{
			NowBullet = MaxBullet;
			MaxBullet = 0;
		}
		ArmAnim.x=0;
		NowMode=STAY;
	}
}

//G̍U󂯂֐
void PlayerStatus::DamegeUpdate(){
	if(DmgFlg==true && Life >= 0){
		DamegeSE[rand()%3].PlayFromStart();
	}
	dmgcount=1;
	DmgFlg=false;
}

//vC[񂾂炱̏(Cxg݂Ȉ)
bool PlayerStatus::DeadUpdate(){
	static int a=255;
	static bool undead=false;
	DeadSE.PlayOnce();
	if(!undead){
		a--;
		Body.SetColor(D3DCOLOR_ARGB(a,255,255,255));
		RightArm.SetColor(D3DCOLOR_ARGB(a,255,255,255));
		LeftArm.SetColor(D3DCOLOR_ARGB(a,255,255,255));
		if(a==0)undead=true;
	}else{
		if(a!=255)a++;
		else return true;
		Dead.SetColor(D3DCOLOR_ARGB(a,255,0,0));
	}
}


PlayerStatus::~PlayerStatus(){
	
}