#include"UI.h"
#include"Window.h"
extern CFONT		*Font;


MouseUI::MouseUI(){
	CursolTex.LoadTex("data\\tex\\ui\\cursol.png",512,512,D3DCOLOR_ARGB(255,0,0,0),d);
	Cursol.Init();
	Cursol.center=D3DXVECTOR2(0,0);
	Cursol.size  =D3DXVECTOR2(64,64);
	Cursol.SetPos();
	Cursol.SetColor(D3DCOLOR_ARGB(255,255,255,255));

}

void MouseUI::SetPos(){
	Cursol.center=ScrPos;
	Cursol.SetPos();
}

void MouseUI::Draw(){
	Cursol.Draw(d,CursolTex.GetTex());
}


MouseUI::~MouseUI(){
	
}





//Q[HUDNX
HUD_UI::HUD_UI(){

	HudBack1Tex.LoadTex("data\\tex\\ui\\HUD_Back.png",1024,256,NULL,d);
	HudBack1.Init();
	HudBack1.center=D3DXVECTOR2(256,64);
	HudBack1.size=D3DXVECTOR2(512,128);
	HudBack1.SetColor(D3DCOLOR_ARGB(255,255,255,255));
	HudBack1.SetPos();

	Arm1Tex.LoadTex("data\\tex\\ui\\PlayerHUD_HG.png",256,256,NULL,d);
	Arm1.Init();
	Arm1.center=D3DXVECTOR2(300,64);
	Arm1.size=D3DXVECTOR2(128,128);
	Arm1.SetColor(D3DCOLOR_ARGB(200,255,255,255));
	Arm1.SetPos();

	AmmoTextTex.LoadTex("data\\tex\\ui\\PlayerHUD2.png",256,128,NULL,d);
	AmmoText.Init();
	AmmoText.center=D3DXVECTOR2(256,96);
	AmmoText.size=D3DXVECTOR2(64,64);
	AmmoText.SetColor(D3DCOLOR_ARGB(200,255,255,255));
	AmmoText.SetPos();

	AmmoTex.LoadTex("data\\tex\\ui\\PlayerHUD_HG_Ammo.png",256,128,NULL,d);
	AmmoQuantity=6;
	for(int i=AmmoQuantity;i>0;i--){
		Ammo[i-1].Init();
		Ammo[i-1].center=D3DXVECTOR2(352+i*18,32);
		Ammo[i-1].size=D3DXVECTOR2(64,64);
		Ammo[i-1].SetColor(D3DCOLOR_ARGB(200,255,255,255));
		Ammo[i-1].SetPos();
	
	}
	//Cto[

		Life1[0].x = 15;Life1[0].y = 100;
		Life1[1].x = 15;Life1[1].y = 50;
		Life1[2].x = 15+LIFE_MAX;Life1[2].y = 50;
		Life1[3].x = 15+LIFE_MAX;Life1[3].y = 100;

		Life2[0].x = 15;Life2[0].y = 100;
		Life2[1].x = 15;Life2[1].y = 50;
		Life2[2].x = 15+LIFE_MAX;Life2[2].y = 50;
		Life2[3].x = 15+LIFE_MAX;Life2[3].y = 100;

	for(int i=0;i<4;i++){

		Life1[i].color=D3DCOLOR_ARGB(255,255,0,0);
		Life2[i].color=D3DCOLOR_ARGB(255,255,255,0);

		Life1[i].z=0;
		Life1[i].rhw=1;
		Life2[i].z=0;
		Life2[i].rhw=1;


	}
	LifeQuantity=1.0f;
}

void HUD_UI::Update(){
	//ce򐔂̍XVie̒ej
	for(int i=AmmoQuantity;i>0;i--){					//摜E珇Ԃɕׂ
		Ammo[i-1].Init();
		Ammo[i-1].center=D3DXVECTOR2(352+i*18,32);
		Ammo[i-1].size=D3DXVECTOR2(64,64);
		Ammo[i-1].SetColor(D3DCOLOR_ARGB(200,255,255,255));
		Ammo[i-1].SetPos();
	
	}
	//Cto[̍XV
	Life2[2].x=15+LIFE_MAX*LifeQuantity;
	Life2[3].x=15+LIFE_MAX*LifeQuantity;
}

void HUD_UI::Draw(){
	HudBack1.Draw(d,HudBack1Tex.GetTex());
	Arm1.Draw(d,Arm1Tex.GetTex());

	for(int i=0;i<AmmoQuantity;i++){
		Ammo[i].Draw(d,AmmoTex.GetTex());
	}

	//e򐔏o
	char DebugOutput	[256];					//o͗p
	sprintf(DebugOutput,"e = %03d ",AmmoMax);
	Font->DrawString(0,0,DebugOutput,D3DCOLOR_XRGB(0,0,0)); 

	//Cto[o
	d->SetRenderState(D3DRS_LIGHTING , FALSE);
	d->SetFVF(FVF_TLVERTEX);
	d->SetTexture(0,NULL);
	d->DrawPrimitiveUP(D3DPT_TRIANGLEFAN, 2, Life1, sizeof(TLVERTEX));
	d->DrawPrimitiveUP(D3DPT_TRIANGLEFAN, 2, Life2, sizeof(TLVERTEX));


}


HUD_UI::~HUD_UI(){
	
}




System_UI::System_UI(){
	GameOver.LoadTex("data\\tex\\system\\gameover.png",640,320,NULL,d);
	GameClear.LoadTex("data\\tex\\system\\clear.png",640,320,NULL,d);

	Ver.Init();
	Ver.SetColor(D3DCOLOR_ARGB(0,255,255,255));
	Ver.size=D3DXVECTOR2(640,320);
	Ver.center=D3DXVECTOR2(WIN_WIDTH/2,WIN_HEIGHT/2);
	Ver.SetPos();

	GameStatus=false;
	fade=FADE_IN;
	alpha=0;
}

void System_UI::Update(){
	switch(fade){
		case FADE_IN:
			if(alpha<255) alpha++;
			break;
		case FADE_OUT:
			if(alpha>0) alpha--;
			break;
		case FADE_STOP:
			break;
	}
	Ver.SetColor(D3DCOLOR_ARGB(alpha,255,255,255));
	Ver.SetPos();

}

void System_UI::Draw(){
	if(GameStatus)Ver.Draw(d,GameClear.GetTex());
	else Ver.Draw(d,GameOver.GetTex());
}


System_UI::~System_UI(){
	
}