//Q[̃[U[C^[tF[X
#ifndef UI_H_
#define UI_H_
#include<d3dx9.h>
#include"Device.h"
#include"CTLVer.h"
#include"CTexture.h"
#include"CFont.h"
#include<stdio.h>

#define LIFE_MAX 200

class MouseUI : public Device{
private:
	CTLVer		Cursol;
	CTexture	CursolTex;
public:
	D3DXVECTOR2 WldPos,ScrPos;			//}EXJ[\̃[hWAXN[W

	MouseUI();
	void SetPos();	//}EX̕`WXV
	void Draw();
	~MouseUI();
};





class HUD_UI : public Device{
private:
	CTLVer HudBack1;
	CTLVer Arm1;
	CTLVer AmmoText;
	CTLVer Ammo[12];

	TLVERTEX Life1[4];				//Cto[iQ{d˂j
	TLVERTEX Life2[4];				//Cto[iQ{d˂j



	CTexture HudBack1Tex;
	CTexture Arm1Tex;
	CTexture AmmoTextTex;
	CTexture AmmoTex;

public:
	int AmmoQuantity;		//\e̗
	int AmmoMax;
	float LifeQuantity;		//\LIFE̗ʁi݂LIFEj(%\L)

	HUD_UI();
	void Update();
	void Draw();
	~HUD_UI();
};

class System_UI : public Device{
private:
	CTLVer Ver;		//Q[I[o[ƃQ[NAtex\t|S

	CTexture GameOver;
	CTexture GameClear;

public:
	bool GameStatus;
	int  fade;				//|S̃tF[hCEtF[hAEgp
	int alpha;				//|S̃At@l


	System_UI();
	void Update();
	void Draw();
	~System_UI();

};

enum fade{
	FADE_IN,
	FADE_OUT,
	FADE_STOP,
};


#endif