#include"Window.h"

#include"Device.h"

#include"Start.h"
#include"Stage1.h"


//-----------------------------------------------------------------------------------------------
// ֐̃vg^Cv
//-----------------------------------------------------------------------------------------------
void	GameLoop(void);
LRESULT CALLBACK WinProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam);
BOOL	CreateD3D(HWND hWnd);
void 	WinMainInit();//
void	Release(void);


//-----------------------------------------------------------------------------------------------
// O[oϐ
//-----------------------------------------------------------------------------------------------

// DirectX֌W
LPDIRECT3D9			g_pd3d		= NULL;
LPDIRECT3DDEVICE9	g_pd3ddev	= NULL;



BOOL g_winflg = TRUE;				// EChE[htO
RECT g_WinRect = {};				// EBhETCYۑp

// _\̂̕ϐ錾

//ԏK
DWORD	g_NowTime;

//t[JE^
float	FrameCounter=0.0f;
int		FPS=0;

//t[io[
int g_FrameNo=START_INIT;

//
BYTE	g_KeyTbl[256];
bool	g_Keyflg[256] = {false};
CDInput* Input;						// CvbgNX
CFONT	 *Font;						// tHgNX



//-----------------------------------------------------------------------------------------------
// ֐FChangeDispMode
// @eFtXN[؂ւ
//-----------------------------------------------------------------------------------------------
void ChangeDispMode(HWND h){

	g_winflg = !g_winflg;	// Ăяo邽тɃtO؂ւ

    D3DPRESENT_PARAMETERS d3dpp = {};

	d3dpp.Windowed  = g_winflg;
	d3dpp.SwapEffect= D3DSWAPEFFECT_DISCARD;

	if(!g_winflg){
		D3DDISPLAYMODE        dmode;
		g_pd3d->GetAdapterDisplayMode(D3DADAPTER_DEFAULT, &dmode);
		d3dpp.BackBufferWidth	= WIN_WIDTH;
		d3dpp.BackBufferHeight	= WIN_HEIGHT;
		d3dpp.BackBufferFormat	= dmode.Format;

		GetWindowRect(h, &g_WinRect);	// ݂̃EBhETCYێ
	}

	g_pd3ddev->Reset(&d3dpp);	

	if (g_winflg){
		SetWindowLong(h, GWL_STYLE, WS_OVERLAPPEDWINDOW);
		// ێꂽEBhETCYɃEBhEč\z
		SetWindowPos(h, HWND_NOTOPMOST,
				g_WinRect.left, g_WinRect.top,
				g_WinRect.right - g_WinRect.left,
				g_WinRect.bottom - g_WinRect.top,
				SWP_SHOWWINDOW);
	}
	else{
		SetWindowLong(h, GWL_STYLE, WS_POPUP);
	}

}

//-----------------------------------------------------------------------------------------------
// ֐FGameLoop
// @eF̊֐WinMainĂ΂
//-----------------------------------------------------------------------------------------------
void GameLoop(void)
{

	g_NowTime = timeGetTime();
	Device::SetDevice(g_pd3ddev);
	
	GetKeyboardState( g_KeyTbl );
	// ̓foCX̃`FbN
	Input->ScanKeyboard();
	Input->ScanMouse();
	Input->ScanJoyStick();


	// RRۂ̃Q[̏LqĂ
	switch(g_FrameNo){
		case START_INIT:
			StartInit();
			break;
		case START_UPDATE:
			StartWork();
			StartUpdate();			// XV
			StartDraw(g_pd3ddev);	// `揈
			break;
		case START_END:
			StartEnd();				//e
			break;

		case STAGE1_INIT:
			Stage1Init();
			break;
		case STAGE1_UPDATE:
			Stage1Work();
			Stage1Update();			// XV
			Stage1Draw(g_pd3ddev);	// `揈
			break;
		case STAGE1_END:
			Stage1End();			//e
			break;

		case ERROR_CHECK:
			break;
		default:
			break;
	}
}

//-----------------------------------------------------------------------------------------------
// ֐FWinProc
// @eFWindowsbZ[W
//-----------------------------------------------------------------------------------------------
LRESULT CALLBACK WinProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	switch(msg){
	case WM_DESTROY:			// EBhE̕{^ꂽ
		Release();
		PostQuitMessage(0);		// I
		return 0;
	case WM_KEYDOWN:
		switch(wParam){
			case VK_ESCAPE:
				Release();
				PostQuitMessage(0);
				return 0;
			case VK_F11:	// ʃ[h̐؂ւ
				//ChangeDispMode(hwnd);
				break;
		}
		return 0;
	}
	return DefWindowProc(hwnd,msg,wParam,lParam);
}


//-----------------------------------------------------------------------------------------------
// ֐FCreateD3D
// @eFDirect3DfoCX쐬
//-----------------------------------------------------------------------------------------------
BOOL CreateD3D(HWND hwnd)
{
	// Direct3DIuWFNg̍쐬
    if(!(g_pd3d = Direct3DCreate9(D3D_SDK_VERSION))){
        MessageBox(hwnd,"Direct3DCreate9 Failed!","CreateD3D",MB_OK);
        return FALSE;
    }

	// Direct3DfoCXIuWFNg̍쐬
    D3DPRESENT_PARAMETERS d3dpp = {};

	d3dpp.Windowed  = g_winflg;
	d3dpp.SwapEffect= D3DSWAPEFFECT_DISCARD;

	if(!g_winflg){
		D3DDISPLAYMODE        dmode;
		g_pd3d->GetAdapterDisplayMode(D3DADAPTER_DEFAULT, &dmode);
		d3dpp.BackBufferWidth	= WIN_WIDTH;
		d3dpp.BackBufferHeight	= WIN_HEIGHT;
		d3dpp.BackBufferFormat	= dmode.Format;
	}


	if(FAILED(g_pd3d->CreateDevice(
        D3DADAPTER_DEFAULT,
        D3DDEVTYPE_HAL,
        hwnd,
        D3DCREATE_SOFTWARE_VERTEXPROCESSING,
        &d3dpp,
        &g_pd3ddev)))
    {
        MessageBox(hwnd,"g_pD3D->CreateDevice Failed!","Create",MB_OK);
        return FALSE;
    }



    return TRUE;
}

//-----------------------------------------------------------------------------------------------
// ֐FRelease
// @eFDirectX֘AIuWFNg
//-----------------------------------------------------------------------------------------------
void Release(void)
{
	if(g_pd3ddev){g_pd3ddev->Release();}

	if(g_pd3d){g_pd3d->Release();}
}

//-----------------------------------------------------------------------------------------------
// ֐FWinMainInit
// @eFWinMain֐̏
//-----------------------------------------------------------------------------------------------
void WinMainInit(void)
{	
	//擾
	srand((unsigned int )time(NULL));	//srand͍ŏɈ񂾂B[vɓȂ
    // eNX`̐ݒ
    g_pd3ddev->SetTextureStageState(0, D3DTSS_ALPHAOP, D3DTOP_MODULATE);//eNX` At@ufBOŐώZs
    //Ɋւl̂Ṕ@eNX`
    g_pd3ddev->SetTextureStageState(0, D3DTSS_COLORARG1, D3DTA_TEXTURE);
    //Ɋւl̂Q́@_񂩂ԂĐꂽliAt@j
    g_pd3ddev->SetTextureStageState(0, D3DTSS_COLORARG2, D3DTA_DIFFUSE);

	// At@EufBOs
    g_pd3ddev->SetRenderState(D3DRS_ALPHABLENDENABLE, TRUE);
    //`it[obt@jAt@EufBOݒ(`挳ƕ`̂Qď߂ēߏ)
    g_pd3ddev->SetRenderState(D3DRS_DESTBLEND, D3DBLEND_INVSRCALPHA);
	//`挳i|SjAt@EufBOݒ
	g_pd3ddev->SetRenderState(D3DRS_SRCBLEND,D3DBLEND_SRCALPHA);


}



//------------------------------------------------------------------------------------------------
// ֐FWinMain
// @eFGg[|CgvO͂n܂
//------------------------------------------------------------------------------------------------
int WINAPI WinMain(HINSTANCE hInst,HINSTANCE hPrev,LPSTR lpszCmdParam,int nCmdshow)
{
	MSG			msg;
	HWND		hwnd;
	char		szAppName[] = "NKC_GAME";

	// EBhENX̏
	WNDCLASSEX	wc = {
		sizeof(WNDCLASSEX),NULL,WinProc,0,0,hInst,NULL,LoadCursor(NULL,IDC_ARROW),
		NULL,NULL,szAppName,NULL
	};
	if(!RegisterClassEx(&wc)){
		return FALSE;					// EBhENXo^
	}

	// EBhẼNCAg̈WIN_WIDTHxWIN_HEIGHTɂ邽߂̌vZ
	int w = WIN_WIDTH  + GetSystemMetrics(SM_CXSIZEFRAME) * 2;
	int h = WIN_HEIGHT + GetSystemMetrics(SM_CYSIZEFRAME) * 2 + GetSystemMetrics(SM_CYCAPTION);

	// EBhE쐬
    if ( g_winflg ) {
        /* EBhEE[hp̃EBhE𐶐 */
        hwnd = CreateWindowEx(
			0,
            szAppName,              // EBhENX̖O
            "GHOST SHOOTER",				// EBhE^Cg
            WS_OVERLAPPEDWINDOW,    // EBhEX^C
            CW_USEDEFAULT,          // EBhE̍pwW
            CW_USEDEFAULT,          // EBhE̍pxW
            w,                      // EBhE̕
            h,                      // EBhE̍
            NULL,                   // eEBhEiȂj
            NULL,                   // j[iȂj
            hInst,                  // ̃vÕCX^X̃nh
            NULL                    // ǉiȂj
        );

    } else {
        /* tXN[E[hp̃EBhE𐶐 */
        hwnd = CreateWindowEx(
			0,
            szAppName,              // EBhENX̖O
            "",						// EBhE^Cg
            WS_VISIBLE | WS_POPUP,  // EBhEX^C
            CW_USEDEFAULT,          // EBhE̍pwW
            CW_USEDEFAULT,          // EBhE̍pxW
            WIN_WIDTH,              // EBhE̕
            WIN_HEIGHT,             // EBhE̍
            NULL,                   // eEBhEiȂj
            NULL,                   // j[iȂj
            hInst,                  // ̃vÕCX^X̃nh
            NULL                    // ǉiȂj
        );
    }

	if(!hwnd)	return FALSE;			// EBhE쐬s

	// Direct3DIuWFNg쐬
	if( !CreateD3D(hwnd) ){
		return FALSE;
	}

	ShowWindow(hwnd,nCmdshow);			// EBhE\
	UpdateWindow(hwnd);					// EBhEXV

	//JOOFF
	g_pd3ddev->SetRenderState(D3DRS_CULLMODE,D3DCULL_NONE);
	//|Sݒ
	//SetTLVertex(g_TLVer, 200 , 100 , 50 , 50 , D3DCOLOR_XRGB(255,255,255) );


	Input = new CDInput(hwnd);				// ̓IuWFNg̍쐬
	Input->InitKeyboard();					// L[{[h̏
	Input->InitMouse(g_winflg,WIN_WIDTH,WIN_HEIGHT);
	Input->InitJoyStick();					// Q[pbh̏
	//Input->InitMouse();

	Font = new CFONT(g_pd3ddev,"lr SVbN",24,30);	//tHgIuWFNg

	WinMainInit();//

	while(1){
		if(PeekMessage(&msg,NULL,0,0,PM_NOREMOVE))
		{
			if(!GetMessage(&msg,NULL,0,0))	break;
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
		else{
			GameLoop();					// ʍXV
		}
	}
	delete Input;							// ̓IuWFNg̉
	delete Font;

	return (int)msg.wParam;

}

