//-------------------------------------------------------------------------------------------------
// t@CF@CAxis.cpp
// @@@eF  [h̎\
// Copyright F@K.Ohishi@2009.11.16
//-------------------------------------------------------------------------------------------------
#include "CAxis.h"

CAxis::CAxis()
{
	Length = 10.0f;	// ̒
	Init();
}

CAxis::~CAxis()
{

}

void CAxis::Init()
{
	// X@
	Ver[0].color    = D3DCOLOR_ARGB(255,255,0,0);
	Ver[1].color    = D3DCOLOR_ARGB(255,255,0,0);
	Ver[0].position = D3DXVECTOR3(0.0f , 0.0f , 0.0f);
	Ver[1].position = D3DXVECTOR3(Length , 0.0f , 0.0f);
	// Y@
	Ver[2].color    = D3DCOLOR_ARGB(255,0,255,0);
	Ver[3].color    = D3DCOLOR_ARGB(255,0,255,0);
	Ver[2].position = D3DXVECTOR3(0.0f , 0.0f , 0.0f);
	Ver[3].position = D3DXVECTOR3(0.0f , Length , 0.0f);
	// Z@
	Ver[4].color    = D3DCOLOR_ARGB(255,0,0,255);
	Ver[5].color    = D3DCOLOR_ARGB(255,0,0,255);
	Ver[4].position = D3DXVECTOR3(0.0f , 0.0f , 0.0f);
	Ver[5].position = D3DXVECTOR3(0.0f , 0.0f , Length);

	// [hs
	D3DXMatrixIdentity(&Wld);
}

void CAxis::Draw(LPDIRECT3DDEVICE9 d)
{
	d->SetTransform(D3DTS_WORLD,&Wld);					// [hϊso^
	d->SetFVF(FVF_AXIS);								// _tH[}bgݒ
	d->SetRenderState(D3DRS_LIGHTING , FALSE);			// CeBOnee
	d->SetTexture( 0, NULL );							// eNX`Ȃ
	d->DrawPrimitiveUP(D3DPT_LINELIST, 3, Ver, sizeof(AXISVER)); 

}

