//-------------------------------------------------------------------------------------------------
// t@CF@CDInput.cpp
// @@@eF  DirectInputɂ̓foCXiL[{[hApbhA}EXj
// Copyright F@K.Ohishi@2009.07.17
//-------------------------------------------------------------------------------------------------
#include "CDInput.h"

//-------------------------------------------------------------------------------------------------
// ֐FCDInput::CDInput()
// T@vFRXgN^:eoϐ̏
// PFEBhEnh
//-------------------------------------------------------------------------------------------------
CDInput::CDInput(HWND h){

	m_hWnd		= h;										// nh擾
	m_pDI		= NULL;										// _CNgCvbgIuWFNg
	m_pKey		= NULL;										// L[{[hIuWFNg
	m_pMouse	= NULL;										// }EXIuWFNg

	for (int i = 0; i < MAX_JOYSTICK; i++){
		m_pJoy[i] = NULL;									// WCXeBbNIuWFNg
	}

	// oϐ
	m_bKey = false;											// L[{[hgptO
	memset(m_key,0,sizeof(m_key));								// ݂̃L[obt@
	memset(m_keyOld,0,sizeof(m_keyOld));						// ÕL[obt@

	m_bMouse = false;											// }EXgptO
	memset(m_btn,0,sizeof(m_btn));								// ݂̃}EXobt@
	memset(m_btnOld,0,sizeof(m_btn));							// Õ}EXobt@

	m_nJoy = 0;												// WCXeBbNfoCX
	m_bJoy = false;											// WCXeBbNgptO 
	m_count = 0;												// JEgp
	memset(m_joy, 0, sizeof(m_joy));							// ݂̃WCXeBbNobt@
	memset(m_joyOld, 0, sizeof(m_joyOld));						// ÕWCXeBbNobt@

	// DirectInpu̍쐬
	DirectInput8Create(GetModuleHandle(NULL), DIRECTINPUT_VERSION, IID_IDirectInput8, (void**)&m_pDI, NULL);
	if(m_pDI == NULL) 	MessageBox(NULL , "DirectInput8Create Error", "cO" , MB_OK);

}

//-------------------------------------------------------------------------------------------------
// ֐FCDInput::~CDInput()
// T@vFfXgN^
// @FȂ
//-------------------------------------------------------------------------------------------------
CDInput::~CDInput(){

	// IuWFNgJ
	ReleaseInput();		

}

//-------------------------------------------------------------------------------------------------
// ֐F CDInput::ReleaseInput()
// T@vF eIuWFNg̊J
// @F Ȃ
//-------------------------------------------------------------------------------------------------
void CDInput::ReleaseInput(){

	// L[{[hIuWFNgJ
	ReleaseKeyboard();

	// }EXIuWFNgJ
	ReleaseMouse();

	// WCXeBbNIuWFNgJ
	ReleaseJoyStick();

	// _CNgCvbgIuWFNgJ
	if(m_pDI != NULL){
		m_pDI->Release();
		m_pDI = NULL;
	}

}

//-------------------------------------------------------------------------------------------------
// ֐F	CDInput::ReleaseKeyboard()
// T@vF	L[{[hIuWFNgJ
// @F Ȃ
//-------------------------------------------------------------------------------------------------
void CDInput::ReleaseKeyboard(){

	// L[{[hIuWFNgJ
	if (m_bKey){
		if (m_pKey) {
			m_pKey->Unacquire();
			if(m_pKey != NULL){
				m_pKey->Release();
				m_pKey = NULL;
			}
		}
	}

}

//-------------------------------------------------------------------------------------------------
// ֐F	CDInput::ReleaseMouse()
// T@vF	}EXIuWFNgJ
// @F Ȃ
//-------------------------------------------------------------------------------------------------
void CDInput::ReleaseMouse(){

	// }EXIuWFNgJ
	if (m_bMouse){
		if (m_pMouse){
			m_pMouse->Unacquire();
			if(m_pMouse != NULL){
				m_pMouse->Release();
				m_pMouse = NULL;
			}
		}
	}

}

//-------------------------------------------------------------------------------------------------
// ֐F	CDInput::ReleaseJoyStick()
// T@vF	WCXeBbNJ
// @F Ȃ
//-------------------------------------------------------------------------------------------------
void CDInput::ReleaseJoyStick(){

	// WCXeBbNIuWFNgJ
	if (m_bJoy){
		for(int i = 0; i < m_nJoy; i++) {
			if (m_pJoy[i]){
				m_pJoy[i]->Unacquire();
				if(m_pJoy[i] != NULL){
					m_pJoy[i]->Release();
					m_pJoy[i] = NULL;
				}
			}
		}
	}

}

//-------------------------------------------------------------------------------------------------
// ֐F	CDInput::InitKeyboard()
// T@vF	L[{[h̏
// @F Ȃ
//-------------------------------------------------------------------------------------------------
BOOL CDInput::InitKeyboard(){

	// foCX쐬
	if( FAILED( m_pDI->CreateDevice(GUID_SysKeyboard, &m_pKey, NULL) )){
		return FALSE;
	}

	// ̓f[^tH[}bgL[{[hɎw
	if( FAILED( m_pKey->SetDataFormat(&c_dfDIKeyboard)) ){
		return FALSE;
	}

	// xݒ
	if( FAILED( m_pKey->SetCooperativeLevel(m_hWnd, DISCL_BACKGROUND | DISCL_NONEXCLUSIVE) ) ){
		return FALSE;
	}

	// ANZX𓾂
	m_pKey->Acquire();

	// gp̗LtOON
	m_bKey = true;

	return TRUE;

}

//-------------------------------------------------------------------------------------------------
// ֐F	CDInput::InitMouse()
// T@vF	}EX̏
// PF EBhE[htO 
// QF XN[
// RF XN[ 
//-------------------------------------------------------------------------------------------------
BOOL CDInput::InitMouse(bool WinMode, int ScWid, int ScHei){

	// foCX쐬
	if( FAILED( m_pDI->CreateDevice(GUID_SysMouse, &m_pMouse, NULL) )){
		return FALSE;
	}

	// ̓f[^tH[}bgL[{[hɎw
	if( FAILED( m_pMouse->SetDataFormat(&c_dfDIMouse)) ){
		return FALSE;
	}

	// xݒ
	if( FAILED( m_pMouse->SetCooperativeLevel(m_hWnd, DISCL_BACKGROUND | DISCL_NONEXCLUSIVE) ) ){
		return FALSE;
	}

	// ANZX𓾂
	m_pMouse->Acquire();

	// gp̗LtOON
	m_bMouse = true;

	// EBhE[hǂ̃tOZbg
	m_winflg = WinMode;

	// XN[ƍZbg
	m_width = ScWid;
	m_height = ScHei;

	// J[\Z^O
	SetCursor(m_width/2, m_height/2);

	return TRUE;

}

//-------------------------------------------------------------------------------------------------
// ֐F	CDInput::InitJoyStick()
// T@vF	WCXeBbN̏
// @F Ȃ
//-------------------------------------------------------------------------------------------------
BOOL CDInput::InitJoyStick(){

	// WCXeBbN̗
	m_pDI->EnumDevices(DI8DEVCLASS_GAMECTRL, EnumJoyCallback, this, DIEDFL_ATTACHEDONLY);

	// 񋓂ʁAWCXeBbÑfoCXȂꍇsB
	if(m_nJoy == 0) {
		wsprintf(m_s,"Number of Joysticks = %d\n",m_nJoy);
		OutputDebugString(m_s);
		return FALSE;
	}

	// 񋓂WCXeBbÑfoCX
	for(int i = 0; i < m_nJoy; i++){

		// ̓f[^tH[}bgWCXeBbNɎw
		if( FAILED( m_pJoy[i]->SetDataFormat(&c_dfDIJoystick2) ) ){
			wsprintf(m_s,"can't set m_joystick[%d]'s format.\n",i);
			OutputDebugString(m_s);
			continue;
		}

		// xݒ
		if( FAILED( m_pJoy[i]->SetCooperativeLevel(m_hWnd, DISCL_BACKGROUND | DISCL_NONEXCLUSIVE) ) ){
			wsprintf(m_s,"can't set m_joystick[%d]'s cooperative level.\n",i);
			OutputDebugString(m_s);
			continue;
		}

		m_count = i;	// WCXeBbÑfoCXJEgێ

		// foCXŎgp\ȓo̓IuWFNg񋓂
		if( FAILED( m_pJoy[i]->EnumObjects(EnumAxisCallback, (VOID*)this, DIDFT_AXIS) ) ){
			wsprintf(m_s,"can't enum m_joystick[%d]'s axis.\n",i);
			OutputDebugString(m_s);
			continue;
		}

		// ANZX𓾂
		m_pJoy[i]->Acquire();
	}

	// gp̗LtOON
	m_bJoy = true;

	return TRUE;

}

//-------------------------------------------------------------------------------------------------
// ֐F	CDInput::Flush()
// T@vF	̓obt@NA
// @F Ȃ
//-------------------------------------------------------------------------------------------------
void CDInput::Flush(){

	memset(m_key,0,sizeof(m_key));				// ݂̃L[obt@
	memset(m_keyOld,0,sizeof(m_keyOld));		// ÕL[obt@

	memset(m_btn,0,sizeof(m_btn));				// ݂̃}EXobt@
	memset(m_btnOld,0,sizeof(m_btn));			// Õ}EXobt@

	memset(m_joy, 0, sizeof(m_joy));			// ݂̃WCXeBbNobt@
	memset(m_joyOld, 0, sizeof(m_joyOld));		// ÕWCXeBbNobt@

}

//-------------------------------------------------------------------------------------------------
// ֐F	CDInput::ScanKeyboard()
// T@vF	L[{[h̏Ԏ擾
// @F Ȃ
//-------------------------------------------------------------------------------------------------
void CDInput::ScanKeyboard(){

	// ĂȂΎ擾Ȃ
	if(!m_bKey) return;

	// ȌԂۑ
	memcpy(m_keyOld, m_key, 256);

	// foCX̏Ԃ擾
	HRESULT hr = m_pKey->GetDeviceState(sizeof(m_key),&m_key);

	//foCX̏Ԃ擾ɎsANZXĎ擾
	if( FAILED(hr) ){

		memset(m_key, 0, 256); //NA

		// ANZXĎ擾
		if(hr == DIERR_INPUTLOST) {
			m_pKey->Acquire();
		}

	}

}

//-------------------------------------------------------------------------------------------------
// ֐F	CDInput::ScanMouse()
// T@vF	}EX̏Ԏ擾
// @F Ȃ
//-------------------------------------------------------------------------------------------------
void CDInput::ScanMouse(){

	// ĂȂΎ擾Ȃ
	if(!m_bMouse) return;

	// DirectInput͍W̃}bsO܂łȂ߁A
	// J[\ʒǔoɂWin32 APIgpB
	GetCursorPos(&m_cursor);

	// EChE[h͍Wnϊ
	if(m_winflg){
		ScreenToClient(m_hWnd, &m_cursor);
		m_cursor.x = min(m_cursor.x, m_width);
		m_cursor.x = max(m_cursor.x, 0);
		m_cursor.y = min(m_cursor.y, m_height);
		m_cursor.y = max(m_cursor.y, 0);
	}

	// ȌԂۑ
	memcpy(m_btnOld, m_btn, 4);

	// NbŇo
	DIMOUSESTATE ms;

	// foCX̏Ԃ擾
	HRESULT hr = m_pMouse->GetDeviceState(sizeof(ms),&ms);

	// foCX̃ANZXĎ擾
	if(hr == DIERR_INPUTLOST){
		m_pMouse->Acquire();
	}
	else{
		memcpy(m_btn, ms.rgbButtons, 4);
		m_wheel = ms.lZ;					// zC[̏Ԃ擾
	}

}

//-------------------------------------------------------------------------------------------------
// ֐F	CDInput::Scam_nJoyStick()
// T@vF	WCXeBbN̏Ԏ擾
// @F Ȃ
//-------------------------------------------------------------------------------------------------
void CDInput::ScanJoyStick(){

	// ĂȂΎ擾Ȃ
	if(!m_bJoy) return;

	// ȌԂۑ
	memcpy(m_joyOld, m_joy, MAX_JOYSTICK*(MAX_BUTTON+6));

	HRESULT hr;
	DIJOYSTATE2 js;

	// WCXeBbÑfoCX[v
	for(int i = 0; i < m_nJoy; i++){

		// f[^̗LfoCXɃ|[OB
		hr = m_pJoy[i]->Poll();

		// WCXeBbÑANZXĎ擾Ă̃foCX
		if(hr == DIERR_INPUTLOST){
			m_pJoy[i]->Acquire();
			continue;
		}
    
		// foCX̏Ԃ擾BsȂ玟̃foCX
		hr = m_pJoy[i]->GetDeviceState(sizeof(DIJOYSTATE2), &js);
		if(hr != DI_OK){
			continue;
		}

		memset(&m_joy[i][0], 0, 6);	// NA

		// WCXeBbN̎{^̏Ԃobt@ɔf
		if(js.lY < -500)		m_joy[i][DIJ_UP    ] = 0x80;
		else if(js.lY > 500)	m_joy[i][DIJ_DOWN  ] = 0x80;

		if(js.lX < -500)		m_joy[i][DIJ_LEFT  ] = 0x80;
		else if(js.lX > 500)	m_joy[i][DIJ_RIGHT ] = 0x80;

		if(js.lZ < -500)		m_joy[i][DIJ_TOP   ] = 0x80;
		else if(js.lZ > 500)	m_joy[i][DIJ_BOTTOM] = 0x80;

		memcpy(&m_joy[i][6], js.rgbButtons, MAX_BUTTON);
	}

}

//-------------------------------------------------------------------------------------------------
// ֐F	CDInput::SetCursor()
// T@vF	J[\W̐ݒ
// @F J[\̍W
//-------------------------------------------------------------------------------------------------
void CDInput::SetCursor(int x,int y){

	POINT cur={x,y};

	// EChE[h͍Wnϊ
	if(m_winflg) ClientToScreen(m_hWnd, &cur);
	
	SetCursorPos(cur.x, cur.y);

}

//-------------------------------------------------------------------------------------------------
// ֐F	CDInput::GetWheel()
// T@vF	zC[ʒu̎擾
// @F Ȃ
//-------------------------------------------------------------------------------------------------
LONG CDInput::GetWheel(){

	return m_wheel;

}

//-------------------------------------------------------------------------------------------------
// ֐F	CDInput::GetCursor()
// T@vF	J[\W̎擾
// @F Ȃ
//-------------------------------------------------------------------------------------------------
POINT CDInput::GetCursor(){

	return m_cursor;

}

//-------------------------------------------------------------------------------------------------
// ֐F	CDInput::GetCursorX()
// T@vF	J[\XW̎擾
// @F Ȃ
//-------------------------------------------------------------------------------------------------
int CDInput::GetCursorX(){

	return m_cursor.x;

}

//-------------------------------------------------------------------------------------------------
// ֐F	CDInput::GetCursorY()
// T@vF	J[\YW̎擾
// @F Ȃ
//-------------------------------------------------------------------------------------------------
int CDInput::GetCursorY(){

	return m_cursor.y;

}

//-------------------------------------------------------------------------------------------------
// ֐F	CDInput::EnumJoyCallback()
// T@vF	WCXeBbN񋓎̃R[obN
// @F Kl
//-------------------------------------------------------------------------------------------------
BOOL CALLBACK CDInput::EnumJoyCallback(const DIDEVICEINSTANCE* pInst, VOID* pThis )
{
	char s[256];

	// NXŃR[obNĂԂ߂ɕKvB
	CDInput* p = (CDInput*)pThis;

	// foCX쐬B
	if( FAILED( p->m_pDI->CreateDevice(pInst->guidInstance, &p->m_pJoy[ p->m_nJoy ], NULL) ) ){
		wsprintf(s,"can't initialize m_joystick[%d].\n",p->m_nJoy);
		OutputDebugString(s);
	}
	
	// WCXeBbNfoCXJEgBőɂȂ񋓏I
	if(++p->m_nJoy == MAX_JOYSTICK) return DIENUM_STOP;
	
	return DIENUM_CONTINUE;

}

//-------------------------------------------------------------------------------------------------
// ֐F	CDInput::EnumAxisCallback()
// T@vF	񋓎̃R[obN
// @F Kl
//-------------------------------------------------------------------------------------------------
BOOL CALLBACK CDInput::EnumAxisCallback(LPCDIDEVICEOBJECTINSTANCE lpddoi,LPVOID pThis )
{
	// NXŃR[obNĂԂ߂ɕKvB
	CDInput* p = (CDInput*)pThis;
	
	DIPROPRANGE diprg;
	
	diprg.diph.dwSize       = sizeof(DIPROPRANGE);
	diprg.diph.dwHeaderSize = sizeof(DIPROPHEADER);
	diprg.diph.dwHow        = DIPH_BYID;
	diprg.diph.dwObj        = lpddoi->dwType;
	diprg.lMin              = -1000;
	diprg.lMax              = +1000;
	
	p->m_pJoy[ p->m_count ]->SetProperty(DIPROP_RANGE, &diprg.diph);
	
	return DIENUM_CONTINUE;

}

//-------------------------------------------------------------------------------------------------
// ֐F	CDInput::KeyHold()
// T@vF	L[Ă邩
// @F o[`L[
//-------------------------------------------------------------------------------------------------
BOOL CDInput::KeyHold(int k){

	return (BOOL)(m_key[k] & 0x80);

}

//-------------------------------------------------------------------------------------------------
// ֐F	CDInput::KeyPush()
// T@vF	L[Ă邩
// @F o[`L[
//-------------------------------------------------------------------------------------------------
BOOL CDInput::KeyPush(int k){

	return (BOOL)(m_key[k]&0x80 && !(m_keyOld[k]&0x80));

}

//-------------------------------------------------------------------------------------------------
// ֐F	CDInput::KeyPull()
// T@vF	L[ꂽuԂ
// @F o[`L[
//-------------------------------------------------------------------------------------------------
BOOL CDInput::KeyPull(int k){

	return (BOOL)(!(m_key[k]&0x80) && m_keyOld[k]&0x80);

}

//-------------------------------------------------------------------------------------------------
// ֐F	CDInput::KeyFree()
// T@vF	L[Ă邩
// @F o[`L[
//-------------------------------------------------------------------------------------------------
BOOL CDInput::KeyFree(int k){

	return (BOOL)(!(m_key[k]&0x80));

}

//-------------------------------------------------------------------------------------------------
// ֐F	CDInput::MouseHold()
// T@vF	}EX{^Ă邩
// @F o[`L[
//-------------------------------------------------------------------------------------------------
BOOL CDInput::MouseHold(int n){

	return (BOOL)(m_btn[n]&0x80);

}

//-------------------------------------------------------------------------------------------------
// ֐F	CDInput::MousePush()
// T@vF	}EX{^ꂽuԂ
// @F o[`L[
//-------------------------------------------------------------------------------------------------
BOOL CDInput::MousePush(int n){

	return (BOOL)(m_btn[n]&0x80 && !(m_btnOld[n]&0x80));

}

//-------------------------------------------------------------------------------------------------
// ֐F	CDInput::MousePull()
// T@vF	}EX{^ꂽuԂ
// @F o[`L[
//-------------------------------------------------------------------------------------------------
BOOL CDInput::MousePull(int n){

	return (BOOL)(!(m_btn[n]&0x80) && m_btnOld[n]&0x80);

}

//-------------------------------------------------------------------------------------------------
// ֐F	CDInput::MouseFree()
// T@vF	}EX{^Ă邩
// @F o[`L[
//-------------------------------------------------------------------------------------------------
BOOL CDInput::MouseFree(int n){

	return (BOOL)(!(m_btn[n]&0x80));

}

//-------------------------------------------------------------------------------------------------
// ֐F	CDInput::JoyHold()
// T@vF	WCpbh̃{^Ă邩
// PF WCpbhID
// QF WCpbhpo[`L[iDIJ_UPj
//-------------------------------------------------------------------------------------------------
BOOL CDInput::JoyHold(int id,int bt){

	return (BOOL)(m_joy[id][bt]&0x80);

}

//-------------------------------------------------------------------------------------------------
// ֐F	CDInput::JoyPush()
// T@vF	WCpbh{^ꂽuԂ
// PF WCpbhID
// QF WCpbhpo[`L[iDIJ_UPj
//-------------------------------------------------------------------------------------------------
BOOL CDInput::JoyPush(int id,int bt){

	return (BOOL)(m_joy[id][bt]&0x80 && !(m_joyOld[id][bt]&0x80));

}

//-------------------------------------------------------------------------------------------------
// ֐F	CDInput::JoyPull()
// T@vF	WCXeBbN{^ꂽuԂ
// PF WCpbhID
// QF WCpbhpo[`L[iDIJ_UPj
//-------------------------------------------------------------------------------------------------
BOOL CDInput::JoyPull(int id,int bt){

	return (BOOL)(!(m_joy[id][bt]&0x80) && m_joyOld[id][bt]&0x80);

}

//-------------------------------------------------------------------------------------------------
// ֐F	CDInput::JoyFree()
// T@vF	WCXeBbN{^Ă邩
// PF WCpbhID
// QF WCpbhpo[`L[iDIJ_UPj
//-------------------------------------------------------------------------------------------------
BOOL CDInput::JoyFree(int id,int bt){

	return (BOOL)(!(m_joy[id][bt]&0x80));

}

//-------------------------------------------------------------------------------------------------
// ֐F	CDInput::ActMapHold()
// T@vF	ipbh or L[{[h́jL[Ă邩
// @F o[`L[
//-------------------------------------------------------------------------------------------------
BOOL CDInput::ActMapHold(int k){

	BOOL flg;

	switch(k){

		case DIA_BUTTON1:	flg =  (BOOL)( (m_key[DIK_Z] & 0x80)		| (m_joy[0][DIJ_1]&0x80)		);	break;
		case DIA_BUTTON2:	flg =  (BOOL)( (m_key[DIK_X] & 0x80)		| (m_joy[0][DIJ_2]&0x80)		);	break;
		case DIA_RETURN:	flg =  (BOOL)( (m_key[DIK_RETURN] & 0x80) | (m_joy[0][DIJ_10]&0x80)		);	break;
		case DIA_SPACE:		flg =  (BOOL)( (m_key[DIK_SPACE] & 0x80)	| (m_joy[0][DIJ_9]&0x80)		);	break;
		case DIA_UP:		flg =  (BOOL)( (m_key[DIK_UP] & 0x80)		| (m_joy[0][DIJ_UP]&0x80)		);	break;
		case DIA_DOWN:		flg =  (BOOL)( (m_key[DIK_DOWN] & 0x80)	| (m_joy[0][DIJ_DOWN]&0x80)	);	break;
		case DIA_LEFT:		flg =  (BOOL)( (m_key[DIK_LEFT] & 0x80)	| (m_joy[0][DIJ_LEFT]&0x80)	);	break;
		case DIA_RIGHT:		flg =  (BOOL)( (m_key[DIK_RIGHT] & 0x80)	| (m_joy[0][DIJ_RIGHT]&0x80)	);	break;

	}

	return flg;

}

//-------------------------------------------------------------------------------------------------
// ֐F	CDInput::ActMapPush()
// T@vF	ipbh or L[{[h́jL[ꂽuԂ
// @F o[`L[
//-------------------------------------------------------------------------------------------------
BOOL CDInput::ActMapPush(int k){

	BOOL flg;

	switch(k){

		case DIA_BUTTON1:
			flg = (BOOL)( (m_key[DIK_Z]&0x80 && !(m_keyOld[DIK_Z]&0x80))			| ( m_joy[0][DIJ_1]&0x80 && !(m_joyOld[0][DIJ_1]&0x80) )		);
			break;
		case DIA_BUTTON2:
			flg = (BOOL)( (m_key[DIK_X]&0x80 && !(m_keyOld[DIK_X]&0x80))			| ( m_joy[0][DIJ_2]&0x80 && !(m_joyOld[0][DIJ_2]&0x80) )		);
			break;
		case DIA_RETURN:
			flg = (BOOL)( (m_key[DIK_RETURN]&0x80 && !(m_keyOld[DIK_RETURN]&0x80)) | ( m_joy[0][DIJ_10]&0x80 && !(m_joyOld[0][DIJ_10]&0x80) )		);
			break;
		case DIA_SPACE:
			flg = (BOOL)( (m_key[DIK_SPACE]&0x80 && !(m_keyOld[DIK_SPACE]&0x80))	| ( m_joy[0][DIJ_9]&0x80 && !(m_joyOld[0][DIJ_9]&0x80) )		);
			break;
		case DIA_UP:
			flg = (BOOL)( (m_key[DIK_UP]&0x80 && !(m_keyOld[DIK_UP]&0x80))			| ( m_joy[0][DIJ_UP]&0x80 && !(m_joyOld[0][DIJ_UP]&0x80) )		);
			break;
		case DIA_DOWN:
			flg = (BOOL)( (m_key[DIK_DOWN]&0x80 && !(m_keyOld[DIK_DOWN]&0x80))		| ( m_joy[0][DIJ_DOWN]&0x80 && !(m_joyOld[0][DIJ_DOWN]&0x80) )	);
			break;
		case DIA_LEFT:
			flg = (BOOL)( (m_key[DIK_LEFT]&0x80 && !(m_keyOld[DIK_LEFT]&0x80))		| ( m_joy[0][DIJ_LEFT]&0x80 && !(m_joyOld[0][DIJ_LEFT]&0x80) )	);
			break;
		case DIA_RIGHT:
			flg = (BOOL)( (m_key[DIK_RIGHT]&0x80 && !(m_keyOld[DIK_RIGHT]&0x80))	| ( m_joy[0][DIJ_RIGHT]&0x80 && !(m_joyOld[0][DIJ_RIGHT]&0x80) ));
			break;

	}

	return flg;

}

//-------------------------------------------------------------------------------------------------
// ֐F	CDInput::ActMapPull()
// T@vF	ipbh or L[{[h́jL[ꂽuԂ
// @F o[`L[
//-------------------------------------------------------------------------------------------------
BOOL CDInput::ActMapPull(int k){

	BOOL flg;

	switch(k){

		case DIA_BUTTON1:
			flg = (BOOL)( ( !(m_key[DIK_Z]&0x80) && m_keyOld[DIK_Z]&0x80 )				| ( !(m_joy[0][DIJ_1]&0x80) && m_joyOld[0][DIJ_1]&0x80 )		);
			break;
		case DIA_BUTTON2:
			flg = (BOOL)( ( !(m_key[DIK_X]&0x80) && m_keyOld[DIK_X]&0x80 )				| ( !(m_joy[0][DIJ_2]&0x80) && m_joyOld[0][DIJ_2]&0x80 )		);
			break;
		case DIA_RETURN:
			flg = (BOOL)( ( !(m_key[DIK_RETURN]&0x80) && m_keyOld[DIK_RETURN]&0x80 )	| ( !(m_joy[0][DIJ_10]&0x80) && m_joyOld[0][DIJ_10]&0x80 )		);
			break;
		case DIA_SPACE:
			flg = (BOOL)( ( !(m_key[DIK_SPACE]&0x80) && m_keyOld[DIK_SPACE]&0x80 )		| ( !(m_joy[0][DIJ_9]&0x80) && m_joyOld[0][DIJ_9]&0x80 )		);
			break;
		case DIA_UP:
			flg = (BOOL)( ( !(m_key[DIK_UP]&0x80) && m_keyOld[DIK_UP]&0x80 )			| ( !(m_joy[0][DIJ_UP]&0x80) && m_joyOld[0][DIJ_UP]&0x80 )		);
			break;
		case DIA_DOWN:
			flg = (BOOL)( ( !(m_key[DIK_DOWN]&0x80) && m_keyOld[DIK_DOWN]&0x80 )		| ( !(m_joy[0][DIJ_DOWN]&0x80) && m_joyOld[0][DIJ_DOWN]&0x80 )	);
			break;
		case DIA_LEFT:
			flg = (BOOL)( ( !(m_key[DIK_LEFT]&0x80) && m_keyOld[DIK_LEFT]&0x80 )		| ( !(m_joy[0][DIJ_LEFT]&0x80) && m_joyOld[0][DIJ_LEFT]&0x80 )	);
			break;
		case DIA_RIGHT:
			flg = (BOOL)( ( !(m_key[DIK_RIGHT]&0x80) && m_keyOld[DIK_RIGHT]&0x80 )		| ( !(m_joy[0][DIJ_RIGHT]&0x80) && m_joyOld[0][DIJ_RIGHT]&0x80 ));
			break;

	}

	return flg;

}

//-------------------------------------------------------------------------------------------------
// ֐F	CDInput::ActMapFree()
// T@vFipbh or L[{[h́jL[Ă邩
// @F o[`L[
//-------------------------------------------------------------------------------------------------
BOOL CDInput::ActMapFree(int k){

	BOOL flg;

	switch(k){

		case DIA_BUTTON1:	flg = (BOOL)( !(m_key[DIK_Z] & 0x80)		| !(m_joy[0][DIJ_1]&0x80)		);	break;
		case DIA_BUTTON2:	flg = (BOOL)( !(m_key[DIK_X] & 0x80)		| !(m_joy[0][DIJ_2]&0x80)		);	break;
		case DIA_RETURN:	flg = (BOOL)( !(m_key[DIK_RETURN] & 0x80) | !(m_joy[0][DIJ_10]&0x80)		);	break;
		case DIA_SPACE:		flg = (BOOL)( !(m_key[DIK_SPACE] & 0x80)	| !(m_joy[0][DIJ_9]&0x80)		);	break;
		case DIA_UP:		flg = (BOOL)( !(m_key[DIK_UP] & 0x80)		| !(m_joy[0][DIJ_UP]&0x80)	);	break;
		case DIA_DOWN:		flg = (BOOL)( !(m_key[DIK_DOWN] & 0x80)	| !(m_joy[0][DIJ_DOWN]&0x80)	);	break;
		case DIA_LEFT:		flg = (BOOL)( !(m_key[DIK_LEFT] & 0x80)	| !(m_joy[0][DIJ_LEFT]&0x80)	);	break;
		case DIA_RIGHT:		flg = (BOOL)( !(m_key[DIK_RIGHT] & 0x80)	| !(m_joy[0][DIJ_RIGHT]&0x80)	);	break;

	}

	return flg;

}

