//---------------------------------------------------------------------------------------------------
// t@CFCDInput.h
// T@@@vFDirectInputNX`(o֐CDInput.cppɋLq)
// Copyright FK.Ohishi@2009.07.17
//---------------------------------------------------------------------------------------------------
#ifndef _CDINPUT_H_	// QdCN[hh~
#define _CDINPUT_H_

#include <dinput.h>
#pragma comment(lib , "dinput8.lib")
//---------------------------------------------------------------------------------------------------
// }N̒`
//---------------------------------------------------------------------------------------------------
#define MAX_JOYSTICK	8							// WCpbh̍ő吔
#define MAX_BUTTON		10							// WCpbh̃{^̍ő吔
#define DIM_LEFT		0							// }EX{^
#define DIM_RIGHT		1							// }EXE{^
#define DIM_MIDDLE		2							// }EX{^izC[j
#define DIJ_UP			0							// WCpbh
#define DIJ_DOWN	    1							// WCpbh
#define DIJ_LEFT	    2							// WCpbh
#define DIJ_RIGHT	    3							// WCpbhE
#define DIJ_TOP			4							// WCpbh
#define DIJ_BOTTOM		5							// WCpbh
#define DIJ_1		    6							// WCpbhP{^
#define DIJ_2			7							// WCpbhQ{^
#define DIJ_3			8							// WCpbhR{^
#define DIJ_4			9							// WCpbhS{^
#define DIJ_5			10							// WCpbhT{^
#define DIJ_6			11							// WCpbhU{^
#define DIJ_7			12							// WCpbhV{^
#define DIJ_8			13							// WCpbhW{^
#define DIJ_9			14							// WCpbhX{^
#define DIJ_10			15							// WCpbh10{^

// ANV}bvpiL[{[hWCpbhj
#define DIA_BUTTON1		0							// WCpbhP{^ or yL[
#define DIA_BUTTON2		1							// WCpbhQ{^ or wL[
#define DIA_RETURN		2							// WCpbhR{^ or ENTERL[
#define DIA_SPACE		3							// WCpbhS{^ or SPACEL[
#define DIA_UP			4							// WCpbhUP @@  or L[
#define DIA_DOWN		5							// WCpbhDOWN     or L[
#define DIA_LEFT		6							// WCpbhLEFT     or L[
#define DIA_RIGHT		7							// WCpbhRIGHT    or L[

//---------------------------------------------------------------------------------------------------
// NX`
//---------------------------------------------------------------------------------------------------
class CDInput{

private:

	//----------------------------------------------------------------------------------
	HWND					m_hWnd;									// EBhEnh
	LPDIRECTINPUT8			m_pDI;									// DirectInputIuWFNg
	LPDIRECTINPUTDEVICE8	m_pKey;									// L[{[hIuWFNg
	LPDIRECTINPUTDEVICE8	m_pMouse;								// }EXIuWFNg
	LPDIRECTINPUTDEVICE8	m_pJoy[MAX_JOYSTICK];					// WCpbhIuWFNg
	//----------------------------------------------------------------------------------
	BOOL					m_bKey;									// L[{[hgp̗LtO
	BYTE					m_key[256];								// ݂̃L[obt@(L[{[h)
	BYTE					m_keyOld[256];							// ÕL[obt@(L[{[h)
	//----------------------------------------------------------------------------------
	BOOL					m_bMouse;								// }EXgp̗LtO
	POINT					m_cursor;								// }EXJ[\ʒu
	BYTE					m_btn[4];								// ݂̃}EX{^obt@
	BYTE					m_btnOld[4];							// Õ}EX{^obt@
	LONG					m_wheel;								// }EXzC[̏
	int						m_width, m_height;						// XN[ƍ
	bool					m_winflg;								// EBhE[hǂ̃tO
	//----------------------------------------------------------------------------------
	BOOL					m_bJoy;									// WCpbhgp̗LtO
	int						m_nJoy;									// WCpbhfoCX
	int						m_count;								// JEgp
	BYTE					m_joy[MAX_JOYSTICK][MAX_BUTTON+6];		// ݂̃{^obt@
	BYTE					m_joyOld[MAX_JOYSTICK][MAX_BUTTON+6];	// Õ{^obt@
	//----------------------------------------------------------------------------------
	char					m_s[256];								// fobOi[p

public:

	CDInput(HWND hwnd);									// RXgN^
	virtual ~CDInput();									// fXgN^

	BOOL InitKeyboard();								// L[{[h̏
	BOOL InitMouse(bool WinMode, int ScWid, int ScHei);	// }EX̏
	BOOL InitJoyStick();								// WCpbh̏

	void ScanKeyboard();								// L[{[h̏Ԏ擾
	void ScanMouse();									// }EX̏Ԏ擾
	void ScanJoyStick();								// WCpbh̏Ԏ擾
	void Flush();										// ̓obt@NA
	void ReleaseInput();								// DIIuWFNgJ
	void ReleaseKeyboard();								// L[{[hIuWFNgJ
	void ReleaseMouse();								// }EXIuWFNgJ
	void ReleaseJoyStick();								// WCpbhJ

	BOOL KeyHold(int k);								// L[Ă邩
	BOOL KeyPush(int k);								// L[ꂽuԂ
	BOOL KeyPull(int k);								// L[ꂽuԂ
	BOOL KeyFree(int k);								// L[Ă邩

	BOOL MouseHold(int n);								// }EX{^Ă邩
	BOOL MousePush(int n);								// }EX{^ꂽuԂ
	BOOL MousePull(int n);								// }EX{^ꂽuԂ
	BOOL MouseFree(int n);								// }EX{^Ă邩
	POINT GetCursor();									// J[\W̎擾
	int GetCursorX();									// J[\XW̎擾
	int GetCursorY();									// J[\YW̎擾
	LONG GetWheel();									// zC[ʒu̎擾
	void SetCursor(int x,int y);						// J[\W̐ݒ
	void ShowCur(BOOL f){ ShowCursor(f); }				// J[\\ON/OFF

	BOOL JoyHold(int id,int bt);						// WCpbh{^Ă邩
	BOOL JoyPush(int id,int bt);						// WCpbh{^ꂽuԂ
	BOOL JoyPull(int id,int bt);						// WCpbh{^ꂽuԂ
	BOOL JoyFree(int id,int bt);						// WCpbh{^Ă邩

	// L[{[hƃpbhAANV}bsO
	BOOL ActMapHold(int k);								// {^Ă邩
	BOOL ActMapPush(int k);								// {^ꂽuԂ
	BOOL ActMapPull(int k);								// {^ꂽuԂ
	BOOL ActMapFree(int k);								// {^Ă邩

private:

	// WCpbh񋓎̃R[obN
	static BOOL CALLBACK EnumJoyCallback(const DIDEVICEINSTANCE* pInst, VOID* pThis);
	// 񋓎̃R[obN
	static BOOL CALLBACK EnumAxisCallback(LPCDIDEVICEOBJECTINSTANCE lpddoi,LPVOID pThis );

};

#endif