//-------------------------------------------------------------------------------------------------
// t@CFCLVer.cpp
// Rg@FCLVerNX̃o֐܂Ƃ߂CPPt@C
// Copyright FK.Ohishi@2009.11.12
//-------------------------------------------------------------------------------------------------
#include "CLVer.h"

//-----------------------------------------------------------------------------------------------
// ֐FCLVer::Init
// @eF3DIuWFNg̏
//-----------------------------------------------------------------------------------------------
void CLVer::Init()
{
	ZeroMemory( ver , sizeof(LVERTEX)*4 );

	for(int i=0 ; i<4 ; i++){
		ver[i].position.x		= (i==1 || i==2) ? 0.5f : -0.5f;
		ver[i].position.y		= (i==2 || i==3) ? -0.5f : 0.5f;
		ver[i].position.z		= 0.0f;
		ver[i].color	= D3DCOLOR_ARGB(0xff,0xff,0xff,0xff);
		ver[i].tu		= (i==1 || i==2)? 1.0f : 0.0f;
		ver[i].tv		= (i==2 || i==3)? 1.0f : 0.0f;
	}
}
//-----------------------------------------------------------------------------------------------
// ֐FCLVer::SetPos
// @eFSWƃTCYRc|ŜS_̒_WZbg(E玞v)
//-----------------------------------------------------------------------------------------------
void CLVer::SetPos()
{
	ver[0].position.x = center.x + (size.x/2);
	ver[1].position.x = center.x - (size.x/2);
	ver[2].position.x = center.x - (size.x/2);	
	ver[3].position.x = center.x + (size.x/2);
	
	ver[0].position.y = center.y - (size.y/2);	
	ver[1].position.y = center.y - (size.y/2);
	ver[2].position.y = center.y + (size.y/2);
	ver[3].position.y = center.y + (size.y/2);

	ver[0].position.z = center.z+50;	
	ver[1].position.z = center.z+50;
	ver[2].position.z = center.z-50;
	ver[3].position.z = center.z-50;

}

//-----------------------------------------------------------------------------------------------
// ֐FCLVer::SetColor
// @eF_J[̃Zbg
// PFF
// QF_
//-----------------------------------------------------------------------------------------------
void CLVer::SetColor(D3DCOLOR c, int point)
{
	for(int i=0 ; i<point ; i++){
		ver[i].color = c;
	}
}

//-----------------------------------------------------------------------------------------------
// ֐FCLVer::SetUV
// @eF_̂tuWZbg
// PFw̕
// QFx̕
// RFw̃R}ʒu
// SFx̃R}ʒu
// TFE]tO
//-----------------------------------------------------------------------------------------------
void CLVer::SetUV(int cx , int cy , int nx , int ny , bool turn)
{
	float w;
	float h;

	// OZh~
	if(cx == 0 || cy == 0){
		MessageBox(NULL,"cx == 0 or cy == 0","SetUV",MB_OK);
		return;
	}
	w = 1.0f / cx;
	h = 1.0f / cy;

	ver[0].tu = w * nx;		ver[0].tv = h * ny;
	ver[1].tu = w * (nx+1);	ver[1].tv = h * ny;
	ver[2].tu = w * (nx+1);	ver[2].tv = h * (ny+1);
	ver[3].tu = w * nx;		ver[3].tv = h * (ny+1);

	if(turn)
	{
		float tu	= ver[0].tu;
		ver[0].tu	= ver[1].tu;
		ver[1].tu	= tu;
		tu			= ver[2].tu; 
		ver[2].tu	= ver[3].tu;
		ver[3].tu	= tu;
	}

}

//-----------------------------------------------------------------------------------------------
// ֐FCLVer::Draw
// @eFRc|S̕`
// PFDirectX`foCX
// QFeNX`|C^
// RF}gbNX|C^
//-----------------------------------------------------------------------------------------------
void CLVer::Draw(LPDIRECT3DDEVICE9 d , LPDIRECT3DTEXTURE9 tex , D3DXMATRIX* pwld)
{
	d->SetTransform(D3DTS_WORLD,pwld);									// [hϊso^
	d->SetFVF(FVF_LVERTEX);												// _tH[}bgݒ
	d->SetRenderState(D3DRS_LIGHTING , FALSE);							// CeBOnee
	d->SetTexture( 0, tex );											// eNX`Ȃ
	d->DrawPrimitiveUP(D3DPT_TRIANGLEFAN, 2, ver, sizeof(LVERTEX));		// `
}
