#include"EnemyStatus.h"


EnemyBase::EnemyBase(){
	DrawFlg=true;
}


EnemyBase::~EnemyBase(){
	
}

//-----------------------------------------------------------------------------------

EnemyStatus1::EnemyStatus1(){
	//|S
	BaseTex.LoadTex("data\\tex\\enemy\\enemy1.png",1024,512,NULL,d);
	BasePolygon.Init();
	BasePolygon.size = D3DXVECTOR2(128,128);
	HitSize=D3DXVECTOR2(64,64);
	BasePolygon.SetPos();
	BasePolygon.SetColor(D3DCOLOR_ARGB(100,255,0,255));
	BasePolygon.SetUV(2,1,0,0,false);
	speed=0.5f+rand()%20*0.1f;
	Life=200+rand()%101;
	MaxLife=Life;
	NowMode=ENEMY_STAY;
	DeadSE.LoadFile(L"data\\sound\\enemy\\umeki.wav");
	SeFlg=false;


}

void EnemyStatus1::AIUpdate(D3DXVECTOR2 PlayerWPos){
	if(DrawFlg){											//\ĂԂvZi׌邩ȁHj
		static float count=3,deg=0;			//̍sɈڂ܂ł̎
		D3DXVECTOR2 EP,REP;					//vC[ƓG̍ (펞XV)

		EP=PlayerWPos-WldPos;
		REP.x= -1*EP.y;	REP.y=EP.x;			//90x]
		D3DXVec2Normalize(&REP,&REP);		//PʃxNgɕϊ
		deg+=0.1f;if(deg>=360)deg=0;
		REP=REP*sin(DEG2RAD(deg));			//TCJ[u{ɂ͂ȃuxړɉ
		//EP.y=EP.y+REP.y+rand()%40-20;
		if(count>0)count -= 0.05f;
		//s̏
		switch(NowMode){
			case ENEMY_STAY:
				//ƂĂ邾ʂɉɂȂ
				BasePolygon.SetUV(2,1,0,0,false);
				break;
			case ENEMY_ATTACK:
				//ǐՏi̓(摜͉])j
				D3DXVec2Normalize(&EP,&EP);
				WldPos += EP*speed + REP * 4.0f;
				BasePolygon.SetUV(2,1,1,0,false);
				break;
			case ENEMY_HOLD:
				D3DXVec2Normalize(&EP,&EP);
				WldPos += EP*speed + REP * (25.0f+rand()%11);
				BasePolygon.SetUV(2,1,1,0,false);
				break;

			case ENEMY_ESCAPE:
				break;
		}

		//vl̏
		if(count<=0){			//̍s߂܂ł̎
			switch(NowMode){
				case ENEMY_STAY:
					if(CircleHitCheck(PlayerWPos,50,WldPos,400+rand()%150)){			//vC[ƓG̋ȓȂvl[`Uɐ؂ւB
						NowMode=ENEMY_ATTACK;
						count=10+rand()%6;												//oƂɌ̂Ƃ̎vlo߂̗
					}

					if(CircleHitCheck(PlayerWPos,30,WldPos,50+rand()%51)){
						NowMode=ENEMY_HOLD;
						count=20+rand()%11;
					}

					break;

				case ENEMY_ATTACK:
					if(CircleHitCheck(PlayerWPos,30,WldPos,50+rand()%51)){
						NowMode=ENEMY_HOLD;
						count=20+rand()%11;
					}

					if(!(CircleHitCheck(PlayerWPos,50,WldPos,600+rand()%101))){			//Uh߂ɍUɐ؂ւƑҋ@ɐ؂ւɂ͍אS̒ӂ𕥂iʂɂBꏏɂȂj
						NowMode=ENEMY_STAY;
						count=20+rand()%11;
					}
					break;

				case ENEMY_HOLD:
					if(!CircleHitCheck(PlayerWPos,30,WldPos,50+rand()%51)){
						NowMode=ENEMY_ATTACK;
						count=10+rand()%11;
					}else{
						NowMode=ENEMY_STAY;
						count=15+rand()%15;
					}

					break;

				case ENEMY_ESCAPE:
					break;

			}

		}

		////HPcʂɉēGalphalςB(:oO)
		//if((float)(Life / MaxLife) <= 0.3f ){
		//	BasePolygon.SetColor(D3DCOLOR_ARGB(100,255,0,255));
		//}else if((float)(Life / MaxLife) <=	0.6f ){
		//	BasePolygon.SetColor(D3DCOLOR_ARGB(150,255,0,255));
		//}else{BasePolygon.SetColor(D3DCOLOR_ARGB(200,255,0,255));}
		
		//BasePolygon.SetColor(D3DCOLOR_ARGB((int)((float)(Life / MaxLife)*255),255,0,255));


		//\̏
		if(Life<=0){
			if(!SeFlg){DeadSE.PlayFromStart(); SeFlg=~SeFlg;}
			DrawFlg=false;
		}
	}
}

void EnemyStatus1::SetPos(){
	BasePolygon.center = ScrPos;
	BasePolygon.SetPos();

}

void EnemyStatus1::Draw(){
	if(DrawFlg){
		BasePolygon.Draw(d,BaseTex.GetTex());
	}
}

EnemyStatus1::~EnemyStatus1(){
}


//------------------------------------------------------------------------------

EnemyStatus2::EnemyStatus2(){
	//|S
	BaseTex.LoadTex("data\\tex\\enemy\\enemy2.png",768,256,NULL,d);
	EffectTex.LoadTex("data\\tex\\enemy\\Exploadr.png",256,256,NULL,d);
	BasePolygon.Init();
	BasePolygon.size = D3DXVECTOR2(128,128);
	HitSize=D3DXVECTOR2(64,64);
	BasePolygon.SetPos();
	BasePolygon.SetColor(D3DCOLOR_ARGB(100,255,0,255));
	BasePolygon.SetUV(3,1,0,0,false);
	Life=5;
	NowMode=ENEMY_STAY;
	TexMode=TEX_TYPE0;
	EffectTime=10;
	
	ExSE.LoadFile(L"data\\sound\\enemy\\hit_axe3.mp3");
	SeFlg=false;
}

void EnemyStatus2::AIUpdate(D3DXVECTOR2 PlayerWPos){
	if(DrawFlg){										//\ĂԂvZi׌邩ȁHj
		static float AnimationTime=0;
		static float count=3;

		if(count>0)count -= 0.05f;


		//s̏
		switch(NowMode){
			case ENEMY_STAY:
				break;
			case ENEMY_EXPLOADR:
				if(AnimationTime<3){
					BasePolygon.SetUV(3,1,(int)AnimationTime,0,false);
					AnimationTime+=0.05f;
					TexMode=TEX_TYPE0;
				}else{
					BasePolygon.SetUV(1,1,0,0,false);
					BasePolygon.size=D3DXVECTOR2(400,400);
					HitSize=D3DXVECTOR2(400,400);
					TexMode=TEX_TYPE1;
					if(EffectTime>=0)EffectTime-=0.05;
					else DrawFlg=false;
				}
				break;
		}

		//vl̏
		if(count<=0){			//̍s߂܂ł̎
			switch(NowMode){
				case ENEMY_STAY:
					if(CircleHitCheck(PlayerWPos,50,WldPos,150) || Life<=0){			//vC[ƓG̋ȓȂvl[`Uɐ؂ւB
						if(Life>0)Life=0;
						if(!SeFlg){ExSE.PlayFromStart();	SeFlg=~SeFlg;}
						NowMode=ENEMY_EXPLOADR;
						count=30+rand()%6;										
					}
					break;
				case ENEMY_EXPLOADR:
					break;
			}
		}
	}
}

void EnemyStatus2::SetPos(){
	BasePolygon.center = ScrPos;
	BasePolygon.SetPos();
}

void EnemyStatus2::Draw(){
	if(DrawFlg){
		switch(TexMode){
			case TEX_TYPE0:
				BasePolygon.Draw(d,BaseTex.GetTex());
				break;
			case TEX_TYPE1:
				BasePolygon.Draw(d,EffectTex.GetTex());
				break;
		}
	}
}

EnemyStatus2::~EnemyStatus2(){
}