#include"MapData.h"

extern CFONT		*Font;


CMapData::CMapData(){
	EnemyKind=0;			//ݎw肵ĂG̎
	ItemKind=0;				//ݎw肵ĂACe̎
	EventKind=0;			//ݎw肵ĂCxg̎

	NowPoint_Map=0;		//Ԗڂ̏𑀍삵Ă邩in`j
	NowPoint_Enemy=0;		//Ԗڂ̏𑀍삵Ă邩iGj
	NowPoint_Item=0;		//Ԗڂ̏𑀍삵Ă邩iACej
	NowPoint_Event=0;		//Ԗڂ̏𑀍삵Ă邩iCxgj

}
//ʒȕ
void CMapData::DataInput(int PointMode,D3DXVECTOR2 Point){
	switch(PointMode){
		case GROUND_DATA:
			MapPoint[NowPoint_Map]=Point;
			NowPoint_Map++;
			break;
		case ENEMY_DATA:
			EnemyPoint[NowPoint_Enemy]=D3DXVECTOR3(Point.x,Point.y,EnemyKind);
			NowPoint_Enemy++;
			break;
		case ITEM_DATA:	
			ItemPoint[NowPoint_Item]=D3DXVECTOR3(Point.x,Point.y,ItemKind);
			NowPoint_Item++;
			break;
		case EVENT_DATA:
			EventPoint[NowPoint_Event]=D3DXVECTOR3(Point.x,Point.y,EventKind);
			NowPoint_Event++;
			break;
		}
}


//GfB^[݂̂ɕKvȊ֐B}bv̈ʒuϊĐ`悷i蔻\j
void CMapData::DrawMapHitLine(LPDIRECT3DDEVICE9 d,float ScrollVol)
{
	D3DXMatrixIdentity(&Wld);
	LINEVER MapHitLine[MAP_POINT_MAX];

	for(int i=0;i<NowPoint_Map;i++){
		MapHitLine[i].rhw=1.0f;
		MapHitLine[i].position=D3DXVECTOR3(MapPoint[i].x-ScrollVol,MapPoint[i].y,0.0f);
		MapHitLine[i].color=D3DCOLOR_ARGB(255,255,0,255);
	}

	d->SetFVF(FVF_AXIS);								// _tH[}bgݒ
	d->SetRenderState(D3DRS_LIGHTING , FALSE);			// CeBOnee
	d->SetTexture( 0, NULL );							// eNX`Ȃ
	d->DrawPrimitiveUP(D3DPT_LINESTRIP, NowPoint_Map-1, MapHitLine, sizeof(LINEVER)); 

}

//}bvȊÕf[^ôɎg
void CMapData::DrawPoint(LPDIRECT3DDEVICE9 d,float ScrollVol){

	CTLVer EPointDraw[ENEMY_POINT_MAX],IPointDraw[ITEM_POINT_MAX],EVPointDraw[EVENT_POINT_MAX]; 
	char DebugOutput	[256];					//o͗p
	for(int i=0;i<NowPoint_Enemy;i++){
		EPointDraw[i].Init();
		EPointDraw[i].size=D3DXVECTOR2(20,20);
		EPointDraw[i].center=D3DXVECTOR2(EnemyPoint[i].x-ScrollVol,EnemyPoint[i].y);
		EPointDraw[i].SetColor(D3DCOLOR_ARGB(255,0,255,255));
		EPointDraw[i].SetPos();
		EPointDraw[i].Draw(d,NULL);
		sprintf(DebugOutput,"%.0f",(EnemyPoint[i].z ) );
		Font->DrawString(EnemyPoint[i].x-ScrollVol,EnemyPoint[i].y,DebugOutput,D3DCOLOR_XRGB(255,0,0)); 
	}
	for(int i=0;i<NowPoint_Item;i++){
		IPointDraw[i].Init();
		IPointDraw[i].size=D3DXVECTOR2(20,20);
		IPointDraw[i].center=D3DXVECTOR2(ItemPoint[i].x-ScrollVol,ItemPoint[i].y);
		IPointDraw[i].SetColor(D3DCOLOR_ARGB(255,255,0,255));
		IPointDraw[i].SetPos();
		IPointDraw[i].Draw(d,NULL);
		sprintf(DebugOutput,"%.0f",ItemPoint[i].z);
		Font->DrawString(ItemPoint[i].x-ScrollVol,ItemPoint[i].y,DebugOutput,D3DCOLOR_XRGB(255,0,0)); 
	}
	for(int i=0;i<NowPoint_Event;i++){
		EVPointDraw[i].Init();
		EVPointDraw[i].size=D3DXVECTOR2(20,20);
		EVPointDraw[i].center=D3DXVECTOR2(EventPoint[i].x-ScrollVol,EventPoint[i].y);
		EVPointDraw[i].SetColor(D3DCOLOR_ARGB(255,60,50,50));
		EVPointDraw[i].SetPos();
		EVPointDraw[i].Draw(d,NULL);
		sprintf(DebugOutput,"%.0f",EventPoint[i].z);
		Font->DrawString(EventPoint[i].x-ScrollVol,EventPoint[i].y,DebugOutput,D3DCOLOR_XRGB(255,0,0)); 
	}
}

//Xe[Wǂݍ
void CMapData::FileInput(int stage_No){
	char filename[128];
	sprintf(filename , "data\\stage\\stage%d.data",stage_No);
	if((fp = fopen(filename,"rb"))==NULL) exit(1);
	fread(&NowPoint_Map,sizeof(int),1,fp);
	fread(&NowPoint_Enemy,sizeof(int),1,fp);
	fread(&NowPoint_Item,sizeof(int),1,fp);
	fread(&NowPoint_Event,sizeof(int),1,fp);
	
	fread(MapPoint,sizeof(D3DXVECTOR2),NowPoint_Map,fp);
	fread(EnemyPoint,sizeof(D3DXVECTOR3),NowPoint_Enemy,fp);
	fread(ItemPoint,sizeof(D3DXVECTOR3),NowPoint_Item,fp);
	fread(EventPoint,sizeof(D3DXVECTOR3),NowPoint_Event,fp);

	fclose(fp);
}

//t@Cւ̏݁it@Cɏój
void CMapData::FileOutPut(int stage_No){
	char filename[128];
	sprintf(filename , "data\\stage\\stage%d.data",stage_No);
	if((fp = fopen(filename,"wb"))==NULL) exit(1);
	fwrite(&NowPoint_Map,sizeof(int),1,fp);
	fwrite(&NowPoint_Enemy,sizeof(int),1,fp);
	fwrite(&NowPoint_Item,sizeof(int),1,fp);
	fwrite(&NowPoint_Event,sizeof(int),1,fp);
	
	fwrite(MapPoint,sizeof(D3DXVECTOR2),NowPoint_Map,fp);
	fwrite(EnemyPoint,sizeof(D3DXVECTOR3),NowPoint_Enemy,fp);
	fwrite(ItemPoint,sizeof(D3DXVECTOR3),NowPoint_Item,fp);
	fwrite(EventPoint,sizeof(D3DXVECTOR3),NowPoint_Event,fp);

	fclose(fp);

}
//t@C̓ǂݍ݁iGfBbgpj
void CMapData::FileInputForEdit(int stage_No){
	char filename[128];
	sprintf(filename , "data\\stage\\stage%d_edit.data",stage_No);
	if((fp = fopen(filename,"rb"))==NULL) exit(1);
	fread(&NowPoint_Map,sizeof(int),1,fp);
	fread(&NowPoint_Enemy,sizeof(int),1,fp);
	fread(&NowPoint_Item,sizeof(int),1,fp);
	fread(&NowPoint_Event,sizeof(int),1,fp);
	
	fread(MapPoint,sizeof(D3DXVECTOR2),NowPoint_Map,fp);
	fread(EnemyPoint,sizeof(D3DXVECTOR3),NowPoint_Enemy,fp);
	fread(ItemPoint,sizeof(D3DXVECTOR3),NowPoint_Item,fp);
	fread(EventPoint,sizeof(D3DXVECTOR3),NowPoint_Event,fp);

	fclose(fp);

}

//f[^̐𒆒fꍇ܂̓obNAbvꍇBGfBbgpB
void CMapData::FileOutPutForEdit(int stage_No){
	char filename[128];
	sprintf(filename , "data\\stage\\stage%d_edit.data",stage_No);
	if((fp = fopen(filename,"wb"))==NULL) exit(1);
	fwrite(&NowPoint_Map,sizeof(int),1,fp);
	fwrite(&NowPoint_Enemy,sizeof(int),1,fp);
	fwrite(&NowPoint_Item,sizeof(int),1,fp);
	fwrite(&NowPoint_Event,sizeof(int),1,fp);
	
	fwrite(MapPoint,sizeof(D3DXVECTOR2),NowPoint_Map,fp);
	fwrite(EnemyPoint,sizeof(D3DXVECTOR3),NowPoint_Enemy,fp);
	fwrite(ItemPoint,sizeof(D3DXVECTOR3),NowPoint_Item,fp);
	fwrite(EventPoint,sizeof(D3DXVECTOR3),NowPoint_Event,fp);

	fclose(fp);
}

CMapData::~CMapData(){
}