#include"MediaPlay.h"


//fBAt@Cǂݍ(mp3ƂwavƂ)
bool Media::LoadFile(BSTR FileName){
	CoInitialize(NULL);
	CoCreateInstance( CLSID_FilterGraph, NULL, CLSCTX_INPROC, IID_IGraphBuilder, (LPVOID *)&pGraphBuilder);
	
	pGraphBuilder->QueryInterface(IID_IMediaControl, (LPVOID *)&pMediaControl );
	pGraphBuilder->QueryInterface(IID_IMediaPosition, (LPVOID *)&pMediaPosition );	
	Result = pMediaControl->RenderFile( FileName );

	switch(Result){
		case S_OK:
			return true;
			break;
		case VFW_S_AUDIO_NOT_RENDERED:
			MessageBox(NULL,"sSȐBI[fBI_O܂łB","Error",MB_OK);
			return false;
			break;
		case VFW_E_INVALID_FILE_FORMAT:
			MessageBox(NULL,"t@CtH[}bgłB","Error",MB_OK);
			return false;
			break;
		case VFW_E_UNSUPPORTED_STREAM:
			MessageBox(NULL,"t@CĐł܂BtH[}bgT|[gĂ܂B","Error",MB_OK);
			return false;
			break;
		case VFW_E_NOT_FOUND:
			MessageBox(NULL,"t@C܂ł","Error",MB_OK);
			return false;
			break;

		default:
			MessageBox(NULL,"̑AsȃG[łBfBAt@Cǂݍ߂܂łB","Error",MB_OK);
			return false;
			break;
	}
}

//񂾂Đ
void Media::PlayOnce(){
	pMediaControl->Run();
	PlayFlg=true;
	PlayLoopFlg=false;
}
//[vĐ
void Media::PlayLoop(){
	pMediaControl->Run();
	PlayFlg=true;
	PlayLoopFlg=true;
}

//[vĐQ
void Media::PlayLoop2(){

	if(PlayFlg && PlayLoopFlg){
		pMediaPosition->get_CurrentPosition(&pos);			//get_CurrentPosition \bh́AXg[̍vԕƂÄ݂ʒu擾B
		pMediaPosition->get_StopTime(&end);					//get_StopTime \bh́AXg[̎ԕƂāAĐ~^C擾B

		if ( pos >= end ){	
			Stop();											//ꎞ~A񏈗
			pMediaControl->Run();
		}
	}else{													
		pMediaControl->Run();
		PlayFlg=true;
		PlayLoopFlg=true;
	}
}
//PlayLoop()ƕp邱Ƃŏ߂ċ@\B[vĐtO`FbNď֐
void Media::PlayLoopCheck(){
	if(PlayFlg && PlayLoopFlg){
		pMediaPosition->get_CurrentPosition(&pos);			//get_CurrentPosition \bh́AXg[̍vԕƂÄ݂ʒu擾B
		pMediaPosition->get_StopTime(&end);					//get_StopTime \bh́AXg[̎ԕƂāAĐ~^C擾B

		if ( pos >= end ){	
			Stop();
			pMediaControl->Run();
		}
	}
}

//Đ̂(F̌ニ[vĐ邩BftHgfalse)
void Media::PlayFromStart(bool LoopFlg){
	pMediaPosition->put_CurrentPosition(0);					//݂̍ĐʒuiԁjŏiOjɂǂ
	pMediaControl->Run();
	PlayFlg=true;
	if(LoopFlg)PlayLoopFlg=true;

}

//ꎞ~
void Media::Pause(){
	pMediaControl->Pause();									//Stop()gĂBĂeꏏňႢȂ
	PlayFlg=false;
}

//~
void Media::Stop(){
	pMediaControl->Stop();
	pMediaPosition->put_CurrentPosition(0);					//Stop()łĐʒu擪ɖ߂Ȃ̂ŁAŖ߂

	PlayFlg=false;
	PlayLoopFlg=false;
}

//ʃAbv
void Media::VolUp(){
	pGraphBuilder->QueryInterface(IID_IBasicAudio, (LPVOID *)&pBasicAudio );

	long vol = 0;
	pBasicAudio->get_Volume( &vol );
	vol += 100;
	if ( vol > 0 ) {
		vol = 0;
	}
	pBasicAudio->put_Volume(vol);
}
//ʃ_E
void Media::VolDown(){
	pGraphBuilder->QueryInterface(IID_IBasicAudio, (LPVOID *)&pBasicAudio );

	long vol = 0;
	pBasicAudio->get_Volume( &vol );
	vol -= 100;
	if ( vol < -10000 ) {
		vol = -10000;
	}
	pBasicAudio->put_Volume(vol);
}
//ʔCӐݒ
void Media::VolUserControl(long Vol){
	pGraphBuilder->QueryInterface(IID_IBasicAudio, (LPVOID *)&pBasicAudio );

	Volume = 0;
	pBasicAudio->get_Volume( &Volume );
	Volume = Vol;
	if( Volume > 0){
		Volume = 0;
	}else if ( Volume < -10000 ) {
		Volume = -10000;
	}
	pBasicAudio->put_Volume(Volume);
}


//J
void Media::Release(){
	if ( pMediaPosition ) {
		pMediaPosition->Release();
		pMediaPosition = NULL;
	}

	if ( pMediaControl ) {
		pMediaControl->Release();
		pMediaControl = NULL;
	}

	if ( pBasicAudio ){
		pBasicAudio->Release();
		pBasicAudio = NULL;
	}
	
	if ( pGraphBuilder ) {
		pGraphBuilder->Release();
		pGraphBuilder = NULL;
		
		CoUninitialize();
	}
}
