#include"StartEvent.h"


StartEvent::StartEvent(){

	EventEnemyTex.LoadTex("data\\tex\\enemy\\enemy1.png",1024,512,NULL,d);
	TitleTex.LoadTex("data\\tex\\title\\title.png",1024,1024,NULL,d);

	for(int i=0;i<50;i++){
		EnemyPos[i]=D3DXVECTOR2(WIN_WIDTH+256+rand()%1024,rand()%WIN_HEIGHT);
		EventEnemy[i].Init();
		EventEnemy[i].size=D3DXVECTOR2(256,256);
		EventEnemy[i].center=EnemyPos[i];
		EventEnemy[i].SetColor(D3DCOLOR_ARGB(128,255,0,0));
		EventEnemy[i].SetUV(2,1,1,0,false);
		EventEnemy[i].SetPos();
	}

	TitlePos=D3DXVECTOR2(WIN_WIDTH+2048,WIN_HEIGHT/2);
	Title.Init();
	Title.center=TitlePos;
	Title.size=D3DXVECTOR2(1024,1024);
	Title.SetColor(D3DCOLOR_ARGB(255,255,255,255));
	Title.SetPos();

}

void StartEvent::Update(){
	for(int i=0;i<50;i++){
		EnemyPos[i] -= D3DXVECTOR2(15,0);
		if(EnemyPos[i].x<-300)EnemyPos[i]=D3DXVECTOR2(WIN_WIDTH+256+rand()%1024,rand()%WIN_HEIGHT);
		EventEnemy[i].center=EnemyPos[i];
		EventEnemy[i].SetPos();
	}

	TitlePos -= D3DXVECTOR2(10,0);
	if(TitlePos.x<WIN_WIDTH/2)TitlePos.x=WIN_WIDTH/2;
	Title.center=TitlePos;
	Title.SetPos();	
}

void StartEvent::Draw(){
	for(int i=0;i<50;i++){
		EventEnemy[i].Draw(d,EventEnemyTex.GetTex());
	}
	Title.Draw(d,TitleTex.GetTex());
	//MessageBox(NULL,"a","|So",MB_OK);

}



StartEvent::~StartEvent(){
	
}
